#ifndef BCellHeader
#define BCellHeader


#include "Header.hh"


class BCell
{
public:
  int cellid;

  int CellMinI;
  int CellMaxI;
  int CellMinJ;
  int CellMaxJ;
  int CellWidth;
  int CellHeight;
  double ContCellHeight;//
  int CellSize;
  int CellDivNr;
  int CellTimeLastDiv;

  double Ra;

  double Rdiv;
  double Relong;
  double Rgrow;
  double Rgrowavg;
  int JustChecked;
  int goodtogotoEZ;

  double AHP6;
  double CKlevel;
  double CKmean;
  double CKsignal;
  double dAHP6;
  double dCKlevel;
  double dCKmean;
  double dCKsignal;
  int polarisation;//0=normal(=down), 1=up(=opposite normal), 2=down(=extra down)
  double pinup;
  double pindown;
  double pinin;
  double dpinup;
  double dpindown;
  double dpinin;
  double auxindif;
  double PBSstate;


  double InvCellSize;
  double MeanCells;
  double AuxinSign;
  double CumAuxin;
  double memARFtot;
  double memARF;
  double epiO;
  double TOLS2;
  double ARF;
  double AA;
  double BB;
  double CC;
  double DD;
  double Plt;
  double Pltexpr;
  double Plts;
  double Pltsexpr;
  double PP;
  double Pin;
  double Aux1;
  double Lax3;
  double Yuc3;
  double Lec2Fus3;
  double Diff;
  double IAAreg;//

  int TimePrevGrowth;
  int CellZonationState;

  BCell();
  ~BCell();
  void CreateCell(int idnr);
  void InitCell();
  void UpdateCell(int t);
  void CopyCell(BCell *c);
  void DiluteCell(BCell *c,int growthtype,int oldh);
};


#endif
