#ifndef TissueHeader
#define TissueHeader

#include "Header.hh"
#include "BCell.hh"

class Tissue
{
public:

  int actcells;
  int maxidnr;
  std::list<BCell*> *CellList;
  typedef std::list<BCell*>::iterator iter;
  BCell* CellGrid[n][m];

  //BCell* trackcelllist[3000];
  //int trackcellidlist[3000];

  //JT_trackingCells
  BCell* trackcelllistPL[3000];
  BCell* trackcelllistPR[3000];
  BCell* trackcelllistVL[3000];
  BCell* trackcelllistVR[3000];
  int trackcellidlistPL[3000];
  int trackcellidlistPR[3000];
  int trackcellidlistVL[3000];
  int trackcellidlistVR[3000];

  Tissue();
  ~Tissue();
  void GenerateTissue();
  void SetUpTissueLayout();
  void TNumberCells();
  void TFindCellCorners();
  void TFindCellSizes();
  void TSetUpMembraneTypes();
  void TInitConditions();
  void Tdsolvetridiag(int ni);
  void UpdateAuxinTissue();
  void UpdateGeneExpressionTissue(int t);
  void UpdateFluxesTissue(int t);
  void DivideCell(BCell *c,int time);
  void CullLateralRootcap(int side);
  void CullOverflowCells(int meani);
  void GrowCell(BCell *c,int time);
  void Growth(int time);
  //reading and writing entire plant from/to file
  void GeneratePlantFromFile(int t);
  void WritePlantToFile(int t);
  //output
  void SaveTotAuxin(int t);
  //void TrackCells(int time);
  //JT_trackingCells
  void TrackCellsPassingBy(double time);
  //void TrackCellsPeriVasc(int time,int type);
  void TrackCellsPeriLeft(int time);
  void TrackCellsPeriRight(int time);
  void TrackCellsVascLeft (int time);
  void TrackCellsVascRight (int time);
  void SaveTemp(int t,int II,int JJ);
  void SaveGradCellularRes(int t);
  void SaveGradGridRes(int t);
  void MakePNG(int t,int flag);
  void MakeSnapshots(int t);
  void TrackWallsSpaceTime(int t, int starttime);//Kymographs
  void VisualiseFluxGridBased(int time);
  void VisualiseFluxCellBased(int time);
  void MakeColorBar();
  void MakeColorWheel();
};

#endif
