#include "BCell.hh"



BCell::BCell()
{
  CellDivNr=0;
  CellTimeLastDiv=0;
}

BCell::~BCell()
{

}

void BCell::CreateCell(int idnr)
{
  cellid=idnr;
  CellSize=0;
}

void BCell::InitCell()
{
  MeanCells=100;
  AuxinSign=0;
  memARF=0;
  memARFtot=0;
  AHP6=0;
  CKlevel=0;
  CKmean=0;
  CKsignal=0;
  dAHP6=0;
  dCKlevel=0;
  dCKmean=0;
  dCKsignal=0;
  polarisation=0;
  pinup=0;
  pindown=1;
  pinin=0.1;
  dpinup=0;
  dpindown=0;
  dpinin=0;
  auxindif=0;
  //PBSstate=0;
  epiO=0;
  TOLS2=0;
  IAAreg=1;//

  Ra=1;//1+0.20*(-0.5+uniform());//to implement noise in the symmetry breaking



  if(CellMaxJ<yLRC1)
    {
      if(CellMaxJ<yLRCstraight)
	Plts=80;
      else
	Plts=50;
    }

  Pin=100;
  Yuc3=0;
  Lec2Fus3=0;
  Aux1=30;


#ifdef LAX3
  Lax3=30;
#else
  Lax3=40;
#endif

  TimePrevGrowth=0;
  Diff=0;
  CellZonationState=0;

  goodtogotoEZ=0;
}

void BCell::UpdateCell(int t)
{
  int q,k;
  

  double dtmemARF,dtmemARFtot;
  double dtPin,dtAux1,dtLax3,dtepiO,dtTOLS2;
  double dtYuc3,dtLec2Fus3,dtPP;
  static double tspeedupstep=tstep*speedup2;

  dtmemARFtot=0;
  dtmemARF=0;
  dtPin=0;
  dtAux1=0;
  dtYuc3=0;
  dtLec2Fus3=0;
  dtLax3=0;
  dtepiO=0;
  dtTOLS2=0;
  
 
#ifdef AUXINSIGNALLING
   AuxinSign=MeanCells+memARF;
#else
   AuxinSign=MeanCells;
   if(Diff>=80 && (memARFtot-memARF)>0)//do we need this? IT DOES MATTER for epifeedback case!
   //if ((memARFtot-memARF)>0)
     //AuxinSign=MeanCells+50*(memARF/(memARFtot-memARF))*(memARFtot/100.);
     AuxinSign=MeanCells+100*(memARF/(memARFtot-memARF))*(memARFtot/100.);   
#endif

  //instantaneous definition of PBS state
  //if((AuxinSign>150 && CellZonationState>50) && PBSstate<100)
   //PBSstate=150;
 

#ifdef AUX1REGULATED
   double auxindep=AuxinSign*AuxinSign/(AuxinSign*AuxinSign+km_aux1*km_aux1);
   //double auxindep=AuxinSign*AuxinSign*AuxinSign*AuxinSign/(AuxinSign*AuxinSign*AuxinSign*AuxinSign+km_aux1*km_aux1*km_aux1*km_aux1);
  Ra=1;
#ifdef SYMMETRYBREAKING
  if(t>250000)
    {
      if(CellMinJ>yLRC1+5*HMZ && Tct[CellMinI][CellMinJ]==8)
	{
	  if(CellMaxI<xm)
	    Ra=1.05;//0.95;//1.10;//1.05;
	  else
	    Ra=0.95;//0.85;//1.0;//0.95;
	}
    }
#endif
  dtAux1=tspeedupstep*(Ra*maxaux1*auxindep-decayaux1*Aux1);
#endif


#ifdef DIRECTFEEDBACK
  //dtLax3=tspeedupstep*(maxlax3*(0.4+1*maxlax3*(AuxinSign*AuxinSign/(AuxinSign*AuxinSign+kmlax3*kmlax3)))-decaylax3*Lax3);

  double kkk=30;
  if(Diff>80)
    dtLax3=tspeedupstep*(maxlax3*(0.4+1*maxlax3*(AuxinSign*AuxinSign/(AuxinSign*AuxinSign+kkk*kkk)))-decaylax3*Lax3);
    else
    dtLax3=tspeedupstep*(maxlax3*(0.4)-decaylax3*Lax3);
  //dtLax3=tspeedupstep*(maxlax3*(0.6)-decaylax3*Lax3);
   
   if(CellMinJ>yLRC1)
      {
	
	if(Tct[CellMinI+1][CellMinJ+1]>=8 && Tct[CellMinI+1][CellMinJ+1]<=11)
	  {
	    //dtYuc3=tspeedupstep*(maxyuc3*(AuxinSign*AuxinSign/(AuxinSign*AuxinSign+75*75))-decayyuc3*Yuc3);
	    if(Diff>80)
	      dtYuc3=tspeedupstep*(maxyuc3*(AuxinSign*AuxinSign/(AuxinSign*AuxinSign+kkk*kkk))-decayyuc3*Yuc3);
	  }
	
	
	if(Diff>80)
	  {
	    double bind=0.5*0.01;
	    double unbind=0.001;
	    double pI=0.01;
	    //double IAAreg=1;
	    double dIbasal=0.0001;
	    double dITIR1=0.001;
	    dtmemARF=tspeedupstep*(unbind*(memARFtot-memARF)-bind*memARF*(pI*IAAreg/(dIbasal+dITIR1*MeanCells)));
	    double ppb=0.001;
	    double ppe=3*0.01;//3*0.01;//ah so now max is at 100!
	    double ddd=0.0001;
	    dtmemARFtot=tspeedupstep*((ppb+ppe*(AuxinSign*AuxinSign/(AuxinSign*AuxinSign+kkk*kkk)))-ddd*memARFtot);
	    //dtmemARFtot=tspeedupstep*((ppb+ppe*(AuxinSign*AuxinSign/(AuxinSign*AuxinSign+75*75)))-ddd*memARFtot);
	  }
	
      }
#endif



   
#ifdef EPIGFEEDBACK
   double bind=0.5*0.01;
   double unbind=0.001;
   double pI=0.01;
   //double IAAreg=1;
   double dIbasal=0.0001;
   double dITIR1=0.001;

   double Kmepig=85;//95;//65;//Test_ARFcheck_5(LAX)/6(LAXYUC):75;//50;//Test_ARF6check_4(LAX):50;
   double qq=Kmepig*Kmepig*Kmepig*Kmepig;//*Kmepig*Kmepig*Kmepig*Kmepig;
   double pp=epiO*epiO*epiO*epiO;//!!!!


   //dynamic translation of epiO to totalARF and then freeARF
   double ppb=3*0.001;//0.01;//0.01;//10*5*0.01;
   double ppe=5*0.01;//0.3*5*0.1;
   double ddd=0.0001;//0.3*0.001;
   double Karf=50;

   
   
   //these setting work reasonably for activating pericycle next to primed vasc
   double Kmp=95;//75;//95;//!!!!!!!!!
   double alphap=1.2*0.01;//0.01;//1.2*0.01;//!!!!!!!
   double aa=AuxinSign*AuxinSign*AuxinSign*AuxinSign;//MeanCells?
   double bb=Kmp*Kmp*Kmp*Kmp;
   double func=aa/(aa+bb);
   double cc=epiO*epiO*epiO*epiO;
   double Kmp2=75;//TryEpiOth4b//60;//TryEpiOth4
   double dd=Kmp2*Kmp2*Kmp2*Kmp2;
   double func2=cc/(cc+dd);
   double betap=1.2*0.0001;//0.0001;//1.2*0.0001;//!!!!!!!!
   double funcoverall=max(func,func2);
   

  

 if(CellMinJ>yLRC1)
   {

#ifndef EPIOONLY
     double kkk=75;


     //free ARF, set free by auxin
     //IAAreg=1;
     dtmemARF=tspeedupstep*(unbind*(memARFtot-memARF)-bind*memARF*(pI*IAAreg/(dIbasal+dITIR1*MeanCells)));

     Ra=1;
#ifdef ARFSYMMETRYBREAKING
     if(CellMinJ>yLRC1+5*HMZ && Tct[CellMinI][CellMinJ]==8)
       {
	 if(CellMaxI<xm)
	   Ra=1.05;//0.95;//1.10;//1.05;
	 else
	   Ra=0.95;//0.85;//1.0;//0.95;
       }
#endif
     double diffact;
     if(Diff<80)
       diffact=0;
     else
       diffact=(pp/(pp+qq));    
     ppb=0.001;
     ppe=3*0.01;//ah so now max is at 100!
     ddd=0.0001;
     //regulated by EpiO
     //dtmemARFtot=tspeedupstep*((ppb+ppe*diffact)-ddd*memARFtot);
     //regulated by EpiO and auxin signalling
     //dtmemARFtot=tspeedupstep*(Ra*(ppb+ppe*diffact*(AuxinSign*AuxinSign/(AuxinSign*AuxinSign+20*20)))-ddd*memARFtot);
     dtmemARFtot=tspeedupstep*(Ra*(ppb+ppe*diffact*(AuxinSign*AuxinSign/(AuxinSign*AuxinSign+30*30)))-ddd*memARFtot);

     
     //question is whether lax3 is involved in early LR steps or
     //only later during emergence stages?
     //LBD29 upstream of LAX3, delay relative to PIN3 activation
     //https://journals.plos.org/plosgenetics/article/figure?id=10.1371/journal.pgen.1008044.g007
     //https://www.nature.com/articles/ncomms9821?proof=t
     double lax3aa=AuxinSign*AuxinSign/(AuxinSign*AuxinSign+kkk*kkk);
     double lax3bb=diffact;
     //one part reg by auxin signalling other part by EpiO
     //dtLax3=tspeedupstep*(maxlax3*(0.4*lax3aa+2*0.6*lax3bb)-decaylax3*Lax3);
     //one part auxin signal, other part EpiO and auxin sign
     //dtLax3=tspeedupstep*(maxlax3*(0.4*lax3aa+2*0.6*diffact*lax3aa)-decaylax3*Lax3);
     //dtLax3=tspeedupstep*(maxlax3*(0.4*lax3aa+2*0.6*diffact*(AuxinSign*AuxinSign/(AuxinSign*AuxinSign+80*80)))-decaylax3*Lax3);
     Ra=1;
#ifdef LAX3SYMMETRYBREAKING
     if(CellMinJ>yLRC1+5*HMZ && Tct[CellMinI][CellMinJ]==8)
       {
	 if(CellMaxI<xm)
	   Ra=1.05;//0.95;//1.10;//1.05;
	 else
	   Ra=0.95;//0.85;//1.0;//0.95;
       }
#endif
     //dtLax3=tspeedupstep*(Ra*maxlax3*(0.4*lax3aa+2*0.6*diffact*(AuxinSign*AuxinSign/(AuxinSign*AuxinSign+40*40)))-decaylax3*Lax3);
     dtLax3=tspeedupstep*(Ra*maxlax3*(0.4*lax3aa+2*0.6*diffact*(AuxinSign*AuxinSign/(AuxinSign*AuxinSign+60*60)))-decaylax3*Lax3);
     //dtLax3=tspeedupstep*(maxlax3*(0.4)*lax3aa-decaylax3*Lax3);
     //dtLax3=tspeedupstep*(maxlax3*(0.6)-decaylax3*Lax3);
     //dtLax3=tspeedupstep*(maxlax3*(0.4)*(MeanCells*MeanCells/(MeanCells*MeanCells+60*60))-decaylax3*Lax3);

     //regulated by EpiO
     //dtYuc3=tspeedupstep*(maxyuc3*diffact-decayyuc3*Yuc3);
     //regulated by Epi and auxin signalling
     //dtYuc3=tspeedupstep*(maxyuc3*diffact*lax3aa-decayyuc3*Yuc3);
     dtYuc3=tspeedupstep*(maxyuc3*diffact*(AuxinSign*AuxinSign/(AuxinSign*AuxinSign+60*60))-decayyuc3*Yuc3);

     //dtYuc3=tspeedupstep*(maxyuc3*diffact*(AuxinSign*AuxinSign/(AuxinSign*AuxinSign+40*40))-decayyuc3*Yuc3);
     //LEC2/FUS3 induce YUC4:
     //https://nph.onlinelibrary.wiley.com/doi/10.1111/nph.14313
     //in somatic embryogenesis lot of links between
     //LEC2/FUS3 and hence the YUCCA they induce and
     //epigenetic silencing
     //https://www.frontiersin.org/articles/10.3389/fpls.2018.01509/full
     //https://link.springer.com/article/10.1007/s11738-017-2487-5
     //https://europepmc.org/article/med/29299323
     //link to reprogramming and auxin!
     //https://onlinelibrary.wiley.com/doi/pdf/10.1111/jipb.12972
  
     //func2=diffact;
     dtepiO=tspeedupstep*(alphap*func-betap*(0.2+0.8*min((1-func),(1-func2)))*epiO);
     //dtepiO=tspeedupstep*(alphap*func-betap*(0.5+0.5*min((1-func),(1-func2)))*epiO);

     double pt=10*0.01;//15*0.01;//10*0.01;//*5*20
     double dt=0.0001;//*5
     dtTOLS2=tspeedupstep*(pt*(memARF*memARF/(memARF*memARF+60*60))-dt*TOLS2);
     //dtTOLS2=tspeedupstep*(pt*(memARF*memARF/(memARF*memARF+40*40))-dt*TOLS2);
     //diffusion in Update
#else
     dtepiO=tspeedupstep*(alphap*func-betap*(0.2+0.8*min((1-func),(1-func2)))*epiO);
#endif
   }
#endif

  memARFtot+=dtmemARFtot;
  memARF+=dtmemARF;
  /*
  ARF+=dtARF;
  AA+=dtAA;
  BB+=dtBB;
  CC+=dtCC;
  DD+=dtDD;
  Plt+=dtPlt;
  Plts+=dtPlts;
  PP+=dtPP;
  */
  Pin+=dtPin;
  Aux1+=dtAux1;
  Lax3+=dtLax3;
  Yuc3+=dtYuc3;
  Lec2Fus3+=dtLec2Fus3;
  epiO+=dtepiO;
  TOLS2+=dtTOLS2;
}


void BCell::CopyCell(BCell *c)
{
  ARF=c->ARF;
  AA=c->AA;
  BB=c->BB;
  CC=c->CC;
  DD=c->DD;
  Plt=c->Plt;
  Plts=c->Plts;
  PP=c->PP;
  Pin=c->Pin;
  Yuc3=c->Yuc3;
  Lec2Fus3=c->Lec2Fus3;
  Aux1=c->Aux1;
  Lax3=c->Lax3;
  MeanCells=c->MeanCells;
  AuxinSign=c->AuxinSign;
  CumAuxin=c->CumAuxin;
  memARF=c->memARF;
  memARFtot=c->memARFtot;
  Rgrow=c->Rgrow;
  Rgrowavg=c->Rgrowavg;
  JustChecked=c->JustChecked;//!!
  CellZonationState=c->CellZonationState;
  Diff=c->Diff;
  AHP6=c->AHP6;
  CKlevel=c->CKlevel;
  CKmean=c->CKmean;
  CKsignal=c->CKsignal;
  dAHP6=c->dAHP6;
  dCKlevel=c->dCKlevel;
  dCKmean=c->dCKmean;
  dCKsignal=c->dCKsignal;
  polarisation=c->polarisation;
  pinup=c->pinup;
  pindown=c->pindown;
  pinin=c->pinin;
  dpinup=c->dpinup;
  dpindown=c->dpindown;
  dpinin=c->dpinin;
  CKmean=c->CKmean;
  auxindif=c->auxindif;
  PBSstate=c->PBSstate;
  epiO=c->epiO;
  TOLS2=c->TOLS2;
  IAAreg=c->IAAreg;//
  //need to introduce halving of TF levels after division?
}

void BCell::DiluteCell(BCell *c,int growthtype,int oldh)
{
  int newh,oldv,newv;
  int fractcyto,volratnonTF,volratTF;

  if(growthtype==0)//cytoplasmic growth so dilution
    {
      //non-TF
      //grow from h=4 to h=9 so +5 but than add walls so -2, so effectively 4+3=7 so +3 so 3/5=0.6
      newh=oldh+0.6;//oldh+1;
      oldv=oldh*c->CellWidth;
      newv=newh*c->CellWidth;
      volratnonTF=(double)oldv/(double)newv;
      //TF
      fractcyto=1;//0.5;
      volratTF=(fractcyto*((double)oldv/(double)newv)+(1-fractcyto));


      //TF
      ARF*=volratTF;
      AA*=volratTF;
      BB*=volratTF;
      CC*=volratTF;
      DD*=volratTF;
      Plt*=volratTF;
      Plts*=volratTF;

      //non-TF
#ifdef PINREGULATED
      Pin*=volratnonTF;
#endif
#ifdef YUC3GH33REGULATED
      Yuc3*=volratnonTF;
      Gh33*=volratnonTF;
#endif
#ifdef AUX1REGULATED
      Aux1*=volratnonTF;
#endif
#ifdef LAX3PREPATTERN
      Lax3*=volratnonTF;
#endif
#ifdef LAX3
      Lax3*=volratnonTF;
#endif
    }
}
