#include "Header.hh"
#include "dSFMT.h"

#include "Tissue.hh"
#include "BCell.hh"
//#include "Cell.hh"

dsfmt_t dsfmt;

double gauss[10000];
double tempcumgauss[100000];
char dirname[1000];
int actcells;

double phase;

//OscillationZone can go?
//IncrAuxin and DiffAuxin both needed?
//BaselineAuxin and BaseMeanCell both needed?

double randnrs[1000];

int idlist[3000];

//int idcounter;
//int memid;

//JT_trackingCells
int idcounter;
int memid;
int idcounter2;
int memid2;
int idcounter3;
int memid3;
int idcounter4;
int memid4;


//grid based properties
double **Caux1;
double **Caux2;
double **Cauxint;
int **Tc;
int **Tmt;
int **Tct;
double **PinPrePat;
double **Cpin1M;
double **Aux1PrePat;
double **Aux1M;
double **Lax3PrePat;
double **Lax3M;
double **Pltsgrid;
double **Pltsgrid2;
double **dummypict;
double *RandNr;


//auxin dynamics
double *a;
double *b;
double *c;
double *rhs;
double *res;
double **paux;
double **daux;
double ***Inf;
double ***Eff;
double ***DiffAuxC;
//graphics
unsigned char *RGBdata;





void Start(int argc, char **argv)
{
  char s[1000];

  if(argc<2)
    {
      printf("usage: exc dirname\n");
      exit(1);
    }
  else
    {
      strcpy(dirname,argv[1]);
    }
}


void MakeArrays()
{
  int i,j,k;

  if( (RandNr=new double[m])== NULL)
    { printf("error in allocating RandNr\n"); exit(1); }
  for(i=0;i<m;i++)
    RandNr[i]=0;
  if( (a=new double[m])== NULL)
    { printf("error in allocating a\n"); exit(1); }
  for(i=0;i<m;i++)
    a[i]=0;
  if( (b=new double[m])== NULL)
    { printf("error in allocating b\n"); exit(1); }
  for(i=0;i<m;i++)
    b[i]=0;
  if( (c=new double[m])== NULL)
    { printf("error in allocating c\n"); exit(1); }
  for(i=0;i<m;i++)
    c[i]=0;
  if( (rhs=new double[m])== NULL)
    { printf("error in allocating rhs\n"); exit(1); }
  for(i=0;i<m;i++)
    rhs[i]=0;
  if( (res=new double[m])== NULL)
    { printf("error in allocating res\n"); exit(1); }
  for(i=0;i<m;i++)
    res[i]=0;
  if( (RGBdata=new unsigned char[(m*zoom)*(n*zoom)*3])== NULL)
    { printf("error in allocating RGB\n"); exit(1); }
  for(i=0;i<((m*zoom)*(n*zoom)*3);i++)
    RGBdata[i]=0;


  //Caux1
  if (( Caux1 = new double*[n]) == NULL )
    { printf("error in allocating Caux1 array\n"); exit(1);}
  for ( i = 0; i < n; i++ )
    {
      if (( Caux1[i] = new double[m]) == NULL )
	{ printf("error in allocating Caux1 array\n"); exit(1);}
    }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      Caux1[i][j]=0;
  //Caux2
  if (( Caux2 = new double*[n]) == NULL )
    { printf("error in allocating Caux2 array\n"); exit(1);}
  for ( i = 0; i < n; i++ )
    {
      if (( Caux2[i] = new double[m]) == NULL )
	{ printf("error in allocating Caux2 array\n"); exit(1);}
    }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      Caux2[i][j]=0;
  //Cauxint
  if (( Cauxint = new double*[n]) == NULL )
    { printf("error in allocating Cauxint array\n"); exit(1);}
  for ( i = 0; i < n; i++ )
    {
      if (( Cauxint[i] = new double[m]) == NULL )
	{ printf("error in allocating Cauxint array\n"); exit(1);}
    }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      Cauxint[i][j]=0;


  //Tc
  if (( Tc = new int*[n]) == NULL )
    { printf("error in allocating Tc array\n"); exit(1);}
  for ( i = 0; i < n; i++ )
    {
      if (( Tc[i] = new int[m]) == NULL )
	{ printf("error in allocating Tc array\n"); exit(1);}
    }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      Tc[i][j]=0;
  //Tmt
  if (( Tmt = new int*[n]) == NULL )
    { printf("error in allocating Tmt array\n"); exit(1);}
  for ( i = 0; i < n; i++ )
    {
      if (( Tmt[i] = new int[m]) == NULL )
	{ printf("error in allocating Tmt array\n"); exit(1);}
    }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      Tmt[i][j]=0;
  //Tct
  if (( Tct = new int*[n]) == NULL )
    { printf("error in allocating Tct array\n"); exit(1);}
  for ( i = 0; i < n; i++ )
    {
      if (( Tct[i] = new int[m]) == NULL )
	{ printf("error in allocating Tct array\n"); exit(1);}
    }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      Tct[i][j]=0;
  //PinPrePat
  if (( PinPrePat =new double*[n]) == NULL )
    { printf("error in allocating PinPrePat array\n"); exit(1);}
  for ( i = 0; i < n; i++ )
    {
      if (( PinPrePat[i] = new double[m]) == NULL )
	{ printf("error in allocating PinPrePat array\n"); exit(1);}
    }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      PinPrePat[i][j]=0;
  //Cpin1M
  if (( Cpin1M =new double*[n]) == NULL )
    { printf("error in allocating Cpin1M array\n"); exit(1);}
  for ( i = 0; i < n; i++ )
    {
      if (( Cpin1M[i] = new double[m]) == NULL )
	{ printf("error in allocating Cpin1M array\n"); exit(1);}
    }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      Cpin1M[i][j]=0;
  //Aux1PrePat
  if (( Aux1PrePat =new double*[n]) == NULL )
    { printf("error in allocating Aux1PrePat array\n"); exit(1);}
  for ( i = 0; i < n; i++ )
    {
      if (( Aux1PrePat[i] = new double[m]) == NULL )
	{ printf("error in allocating Aux1PrePat array\n"); exit(1);}
    }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      Aux1PrePat[i][j]=0;
  //Aux1M
  if (( Aux1M =new double*[n]) == NULL )
    { printf("error in allocating Aux1M array\n"); exit(1);}
  for ( i = 0; i < n; i++ )
    {
      if (( Aux1M[i] = new double[m]) == NULL )
	{ printf("error in allocating Aux1M array\n"); exit(1);}
    }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      Aux1M[i][j]=0;
  //Lax3PrePat
  if (( Lax3PrePat =new double*[n]) == NULL )
    { printf("error in allocating Lax3PrePat array\n"); exit(1);}
  for ( i = 0; i < n; i++ )
    {
      if (( Lax3PrePat[i] = new double[m]) == NULL )
	{ printf("error in allocating Lax3PrePat array\n"); exit(1);}
    }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      Lax3PrePat[i][j]=0;
  //Lax3M
  if (( Lax3M =new double*[n]) == NULL )
    { printf("error in allocating Lax3M array\n"); exit(1);}
  for ( i = 0; i < n; i++ )
    {
      if (( Lax3M[i] = new double[m]) == NULL )
	{ printf("error in allocating Lax3M array\n"); exit(1);}
    }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      Lax3M[i][j]=0;
  //Pltsgrid
  if (( Pltsgrid =new double*[n]) == NULL )
    { printf("error in allocating Pltsgrid array\n"); exit(1);}
  for ( i = 0; i < n; i++ )
    {
      if (( Pltsgrid[i] = new double[m]) == NULL )
	{ printf("error in allocating Pltsgrid array\n"); exit(1);}
    }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      Pltsgrid[i][j]=0;
   //Pltsgrid2
  if (( Pltsgrid2 =new double*[n]) == NULL )
    { printf("error in allocating Pltsgrid2 array\n"); exit(1);}
  for ( i = 0; i < n; i++ )
    {
      if (( Pltsgrid2[i] = new double[m]) == NULL )
	{ printf("error in allocating Pltsgrid2 array\n"); exit(1);}
    }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
    Pltsgrid2[i][j]=0;
  //dummypict
  if (( dummypict =new double*[n]) == NULL )
    { printf("error in allocating dummypict array\n"); exit(1);}
  for ( i = 0; i < n; i++ )
    {
      if (( dummypict[i] = new double[m]) == NULL )
	{ printf("error in allocating dummypict array\n"); exit(1);}
    }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
    dummypict[i][j]=0;

  //paux
  if (( paux = new double*[n]) == NULL )
    { printf("error in allocating paux array\n"); exit(1);}
  for ( i = 0; i < n; i++ )
    {
      if (( paux[i] = new double[m]) == NULL )
	{ printf("error in allocating paux array\n"); exit(1);}
    }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      paux[i][j]=0;
  //daux
  if (( daux = new double*[n]) == NULL )
    { printf("error in allocating daux array\n"); exit(1);}
  for ( i = 0; i < n; i++ )
    {
      if (( daux[i] = new double[m]) == NULL )
	{ printf("error in allocating daux array\n"); exit(1);}
    }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      daux[i][j]=0;


  //3D arrays
  //Inf
  if (( Inf= new double**[n]) == NULL )
    { printf("error in allocating Inf array\n"); exit(1);}
  for(i = 0; i < n; i++) {
    if (( Inf[i]= new double*[m]) == NULL )
      { printf("error in allocating Inf array\n"); exit(1);}
    for(j=0; j < m; j++){
       if (( Inf[i][j]= new double[4]) == NULL )
	 { printf("error in allocating Inf array\n"); exit(1);}
    }
  }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      for(k=0;k<4;k++)
	Inf[i][j][k]=0;
  //Eff
  if (( Eff= new double**[n]) == NULL )
    { printf("error in allocating Eff array\n"); exit(1);}
  for(i = 0; i < n; i++) {
    if (( Eff[i]= new double*[m]) == NULL )
      { printf("error in allocating Eff array\n"); exit(1);}
    for(j=0; j < m; j++){
       if (( Eff[i][j]= new double[4]) == NULL )
	 { printf("error in allocating Eff array\n"); exit(1);}
    }
  }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      for(k=0;k<4;k++)
	Eff[i][j][k]=0;
  //DiffAuxC
  if (( DiffAuxC= new double**[n]) == NULL )
    { printf("error in allocating DiffAuxC array\n"); exit(1);}
  for(i = 0; i < n; i++) {
    if (( DiffAuxC[i]= new double*[m]) == NULL )
      { printf("error in allocating DiffAuxC array\n"); exit(1);}
    for(j=0; j < m; j++){
       if (( DiffAuxC[i][j]= new double[4]) == NULL )
	 { printf("error in allocating DiffAuxC array\n"); exit(1);}
    }
  }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      for(k=0;k<4;k++)
	DiffAuxC[i][j][k]=0;
}



void FreeArrays()
{
  int i,j;


  delete[] RandNr;
  delete[] a;
  delete[] b;
  delete[] c;
  delete[] rhs;
  delete[] res;
  delete[] RGBdata;

  for(i = 0; i < n; i++)
    delete[] Caux1[i];
  delete[] Caux1;
  for(i = 0; i < n; i++)
    delete[] Caux2[i];
  delete[] Caux2;
  for(i = 0; i < n; i++)
    delete[] Cauxint[i];
  delete[] Cauxint;
  for(i = 0; i < n; i++)
    delete[] Tc[i];
  delete[] Tc;
  for(i = 0; i < n; i++)
    delete[] Tmt[i];
  delete[] Tmt;
  for(i = 0; i < n; i++)
    delete[] Tct[i];
  delete[] Tct;
  for(i = 0; i < n; i++)
    delete[] PinPrePat[i];
  delete[] PinPrePat;
  for(i = 0; i < n; i++)
    delete[] Cpin1M[i];
  delete[] Cpin1M;
  for(i = 0; i < n; i++)
    delete[] Aux1PrePat[i];
  delete[] Aux1PrePat;
  for(i = 0; i < n; i++)
    delete[] Aux1M[i];
  delete[] Aux1M;
  for(i = 0; i < n; i++)
    delete[] Lax3PrePat[i];
  delete[] Lax3PrePat;
  for(i = 0; i < n; i++)
    delete[] Lax3M[i];
  delete[] Lax3M;
  for(i = 0; i < n; i++)
    delete[] Pltsgrid[i];
  delete[] Pltsgrid;
  for(i = 0; i < n; i++)
    delete[] Pltsgrid2[i];
  delete[] Pltsgrid2;
  for(i = 0; i < n; i++)
    delete[] dummypict[i];
  delete[] dummypict;
  for(i = 0; i < n; i++)
    delete[] paux[i];
  delete[] paux;
  for(i = 0; i < n; i++)
    delete[] daux[i];
  delete[] daux;



  //3D arrays
  for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	delete[] Inf[i][j];
      delete[] Inf[i];
    }
  delete[] Inf;
  for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	delete[] Eff[i][j];
      delete[] Eff[i];
    }
  delete[] Eff;
  for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	delete[] DiffAuxC[i][j];
      delete[] DiffAuxC[i];
    }
  delete[] DiffAuxC;
}


void fillgauss()
{
  int i;
  int j;
  double ii;
  double gg;
  double min=-2.58;//-4;
  double max=2.58;//4;
  double cum=0;

  for(i=0;i<100000;i++)
    tempcumgauss[i]=0;

  for(i=0;i<100000;i++)//fill normal cum gauss array
    {
      ii=i*0.0001-5;

      if(ii>=min && ii<=max)
	gg=(1./(sqrt(2*M_PI)))*exp(-ii*ii/2);
      else
	gg=0;
      cum+=gg*0.0001;
      tempcumgauss[i]=cum;
      //printf("%i %f %f %f\n",i,ii,gg,tempcumgauss[i]);
    }

  //correction for cutoff of gaussian at -2.54 and 2.54
  double maxcum=tempcumgauss[100000-1];
  for(i=0;i<100000;i++)
    {
      tempcumgauss[i]=tempcumgauss[i]/maxcum;
      //printf("%f %f\n",i*0.0001-5,tempcumgauss[i]);
    }

  for(i=0;i<10000;i++)//derive inverted array
    {
      ii=i*0.0001;
      j=0;
      while(tempcumgauss[j]<ii)
	j++;
      gauss[i]=j*0.0001-5;//-max;
      //printf("%i %f %f\n",i,ii,gauss[i]);
    }
}


double min(double a, double b)
{
  if(a<b)
    return a;
  else
    return b;
}

double max(double a, double b)
{
  if(a>b)
    return a;
  else
    return b;
}

int main(int argc, char **argv)
{
  int time;
  int i,j,q;
  int starttime;

  
  for(i=0;i<1000;i++)
    randnrs[i]=rand()/RAND_MAX;


  Start(argc,argv);
  MakeArrays();
  fillgauss();

  Tissue *T;
  T=new Tissue();

  dsfmt_init_gen_rand(&dsfmt,18);

#ifndef RESTART
  starttime=1;
  //InitPlant();
  T->GenerateTissue();
  //MakeGraphics(0);
  T->MakeSnapshots(0);
#else
  starttime=250000;//400000;//250000;
  //InitPlantFromFile(starttime);
  T->GeneratePlantFromFile(starttime);
  printf("read in file\n");
  //MakeGraphics(starttime);
  T->MakeSnapshots(starttime);
  starttime=(int)(starttime/tstep);
#endif

  //printf("n %i m %i endMZ/startEZ %i endEZ/startDZ %i\n",n,m,yLRC1,yLRC1+10*HEZ);

  //T->MakeColorBar();
  T->MakeColorWheel();


  //T->TrackCells(starttime);
  //JT_trackingCells
  T->TrackCellsPeriLeft(starttime);
  T->TrackCellsPeriRight(starttime);
  T->TrackCellsVascLeft(starttime);
  T->TrackCellsVascRight(starttime);
  /*
  T->TrackCellsPeriVasc((int)(time*tstep),1);
  T->TrackCellsPeriVasc((int)(time*tstep),2);
  T->TrackCellsPeriVasc((int)(time*tstep),3);
  T->TrackCellsPeriVasc((int)(time*tstep),4);
  */
  //T->TrackCells(0);

  printf("n %i m %i\n",n,m);
  printf("yLRC1 is %i TZ boundary is %i\n",yLRC1,yLRC1-(15*HMZ+15));

  for(time=starttime;time<=maxnrsteps;time++)
    {
      T->UpdateAuxinTissue();


      if(time%speedup2==0)
	{
	  T->UpdateGeneExpressionTissue((int)(time*tstep));

	  T->Growth((int)(time*tstep));

	  T->UpdateFluxesTissue((int)(time*tstep));

	  T->TrackCellsPassingBy(double(time*tstep));


	  //T->TrackCells((int)(time*tstep));
	  //JT_trackingCells
	  T->TrackCellsPeriLeft((int)(time*tstep));
	  T->TrackCellsVascLeft((int)(time*tstep));
	  T->TrackCellsPeriRight((int)(time*tstep));
	  T->TrackCellsVascRight((int)(time*tstep));
	  /*
	  T->TrackCellsPeriVasc((int)(time*tstep),1);
	  T->TrackCellsPeriVasc((int)(time*tstep),2);
	  T->TrackCellsPeriVasc((int)(time*tstep),3);
	  T->TrackCellsPeriVasc((int)(time*tstep),4);
	  */
	}



      if((int)(time*tstep)>0 && ((int)(time*tstep))%50000==0)
	T->WritePlantToFile((int)(time*tstep));
      if((int)(time*tstep)==406080)
	T->WritePlantToFile((int)(time*tstep));


      if(time%250==0)
      {
	T->SaveTotAuxin((int)(time*tstep));
	T->TrackWallsSpaceTime((int)(time*tstep), starttime);//Kymographs
      }


      if(time%tsave==0)
	{

	  //T->SaveGradCellularRes((int)(time*tstep));
	  T->SaveGradGridRes((int)(time*tstep));

	 
	  T->MakeSnapshots((int)(time*tstep));

	  //T->VisualiseFluxGridBased((int)(time*tstep));
	  T->VisualiseFluxCellBased((int)(time*tstep));
	}
    }

  //FreeArrays();


  return 0;
}
