#include "Tissue.hh"

#include "BCell.hh"


#define TRACKPRIMING
//#define TRACKGROWTH

void Tissue::SaveTotAuxin(int t)
{
  FILE *f;
  int i,j;
  char s[900];

  double Auxtot=0;
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
	if(Tc[i][j]!=3)
	  Auxtot+=Caux1[i][j];
      }

  sprintf(s,"%s/Totalauxin",dirname);
  f=fopen(s,"a");
  fprintf(f,"%i\t%f\t%f\n",t,Auxtot,Auxtot/(n*m));
  fclose(f);
}


void Tissue::TrackCellsPassingBy(double time)
{
  FILE *f;
  char fname[600];
  BCell *cp;
  BCell *cv;
  int valp;
  int valv;

  int iip=disttoepi+totsizeepi+totsizeendo+totsizecort+2;//+1
  int iiv=disttoepi+totsizeepi+totsizeendo+totsizecort+totsizeperi+2;//+1
  int jj=yLRC1-5*HMZ-5-1;


  sprintf(fname,"%s/TrackCellPassingBy2",dirname);
  f=fopen(fname,"a");
  if(Tc[iip][jj]==0)
    valp=0;
  else if(Tc[iip][jj]==3)
    valp=3;
  else
    {
      cp=CellGrid[iip][jj];
      valp=cp->cellid;
    }
  if(Tc[iiv][jj]==0)
    valv=0;
  else if(Tc[iiv][jj]==3)
    valv=3;
  else
    {
      cv=CellGrid[iiv][jj];
      valv=cv->cellid;
    }
  fprintf(f,"%i \t %i \t %i\n",(int)time,valp,valv);
  fclose(f);

}


/*
void Tissue::TrackCellsPeriVasc(int time,int type)
{
  //1=peri left
  //2=peri right
  //3=vasc left
  //4=vasc right


  BCell *c;
  iter it1;
  static int first_time=0;
  static int periL_i=disttoepi+totsizeepi+totsizeendo+totsizecort+1;
  static int periR_i=n-1-(disttoepi+totsizeepi+totsizeendo+totsizecort+1);
  static int vascL_i=disttoepi+totsizeepi+totsizeendo+totsizecort+totsizeperi+1;
  static int vascR_i=n-1-(disttoepi+totsizeepi+totsizeendo+totsizecort+totsizeperi+1);
#ifdef TRACKPRIMING
  static int periL_j=yLRC1-5*HMZ-5-1;
  static int periR_j=yLRC1-5*HMZ-5-1;
  static int vascL_j=yLRC1-5*HMZ-5-1;
  static int vascR_j=yLRC1-5*HMZ-5-1;
#endif
#ifdef TRACKGROWTH
  static int periL_j=yLRC1-30*HMZ-30-1;
  static int periR_j=yLRC1-30*HMZ-30-1;
  static int vascL_j=yLRC1-30*HMZ-30-1;
  static int vascR_j=yLRC1-30*HMZ-30-1;
#endif
  int i1;
  FILE *f;
  char fname[600];
  int cellstillexists;

  if(first_time==0)//initialisation
    {
      memid=-1;
      for(i1=0;i1<3000;i1++)
	{
	  if(type==1)
	    {
	      trackcelllistPL[i1]=NULL;
	      trackcellidlistPL[i1]=-1;
	    }
	  else if(type==2)
	    {
	      trackcelllistPR[i1]=NULL;
	      trackcellidlistPR[i1]=-1;
	    }
	  else if(type==3)
	    {
	      trackcelllistVL[i1]=NULL;
	      trackcellidlistVL[i1]=-1;
	    }
	  else if(type==4)
	    {
	      trackcelllistVR[i1]=NULL;
	      trackcellidlistVR[i1]=-1;
	    }
	}

      first_time=1;
      idcounterpl=0;
    }
  else//the real stuff
    {
      if(type==1)
	c=CellGrid[periL_i][periL_j];
      else if(type==2)
	c=CellGrid[periR_i][periR_j];
      else if(type==3)
	c=CellGrid[vascL_i][vascL_j];
      else if(type==4)
	c=CellGrid[vascR_i][vascR_j];
      if(c!=NULL && c->cellid!=memid)//new cell arrived!
	{
	  memid=c->cellid;
	  if(type==1)
	    idcounterpl++;//THIS MEANS STORAGE IS FROM POSITION 1 ONWARDS
	  else if(type==2)
	    idcounterpr++;
	  else if(type==3)
	    idcountervl++;
	  else if(type==4)
	    idcountervr++;
	  if(type==1)
	    {
	      trackcelllistPL[idcounterpl]=c;//store pointer to cell
	      trackcellidlistPL[idcounterpl]=c->cellid;//store cell id
	    }
	  else if(type==2)
	    {
	      trackcelllistPR[idcounterpr]=c;//store pointer to cell
	      trackcellidlistPR[idcounterpr]=c->cellid;//store cell id
	    }
	  else if(type==3)
	    {
	      trackcelllistVL[idcountervl]=c;//store pointer to cell
	      trackcellidlistVL[idcountervl]=c->cellid;//store cell id
	    }
	  else if(type==4)
	    {
	      trackcelllistVR[idcountervr]=c;//store pointer to cell
	      trackcellidlistVR[idcountervr]=c->cellid;//store cell id
	    }

	  //printf("found cell %i\n",c->cellid);
	}
      if(idcounter>=3000)
	printf("idcounter is larger then 3000, array overflow!\n");


      int targetid;
      //COULD THIS SOMEHOW GO WRONG BY DOING IT ONLY EVEREY 300TH STEP????
      if(time%300==0 && idcounter>0)//each 300th timestep, starting once a first cell is found
	{
	  for(i1=1;i1<=min(idcounter,2999);i1++)//for each cell thusfar found at end MZ
	    {
	      cellstillexists=0;//find if that cell still exists
	      it1=CellList->begin();
	      while(it1!=CellList->end())//loop over cell list
		{
		  c=(*it1);
		  if(type==1)
		    targetid=trackcellidlistPL[i1];
		  else if(type==2)
		    targetid=trackcellidlistPR[i1];
		  else if(type==3)
		    targetid=trackcellidlistVL[i1];
		  else if(type==4)
		    targetid=trackcellidlistVR[i1];
		  if(c->cellid==targetid)//cell with this id still exists
		    {
		      cellstillexists=1;
		      break;
		    }
		  it1++;
		}
	      if(cellstillexists==1)//if cell still exists
		{
		  if(type==1)
		    {
		      c=trackcelllistPL[i1];//access the cell
		      sprintf(fname,"%s/TrackCellPeriLeft_%d",dirname,i1);//writing in unique file per cell
		    }
		  else if(type==2)
		    {
		      c=trackcelllistPR[i1];//access the cell
		      sprintf(fname,"%s/TrackCellPeriRight_%d",dirname,i1);//writing in unique file per cell
		    }
		  else if(type==3)
		    {
		      c=trackcelllistVL[i1];//access the cell
		      sprintf(fname,"%s/TrackCellVascLeft_%d",dirname,i1);//writing in unique file per cell
		    }
		  else if(type==4)
		    {
		      c=trackcelllistVR[i1];//access the cell
		      sprintf(fname,"%s/TrackCellVascRight_%d",dirname,i1);//writing in unique file per cell
		    }
		  
		  f=fopen(fname,"a");
		  //write time, auxin, Aux1, diff status, cell height, cell j position,
		  fprintf(f,"%f\t%f\t%f\t%f\t%i\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\n",(time/3600.0),c->MeanCells,c->Aux1, c->PP, c->CellHeight,c->Diff,(0.5*(c->CellMinJ+c->CellMaxJ)),c->memARF,c->memARFtot,c->Pin,c->AuxinSign,c->CumAuxin,c->AHP6,c->CKlevel,c->CKmean,c->CKsignal,c->pindown,c->pinup,c->pinin,c->epiO,c->Yuc3,c->Lax3);//,c->Lec2,c->Fus3,c->Yucca4);
		  fclose(f);
		}
	    }
	}
    }
}
*/



//JT_trackingCells
//JT_LFYfeedback
void Tissue::TrackCellsPeriLeft(int time)
{
#ifndef DEBUGMODE
  BCell *c;
  iter it1;
  static int first_time=0;
  static int periL_i=disttoepi+totsizeepi+totsizeendo+totsizecort+1;
#ifdef TRACKPRIMING
  static int periL_j=yLRC1-5*HMZ-5-1;
#endif
#ifdef TRACKGROWTH
  static int periL_j=yLRC1-30*HMZ-30-1;
#endif
  int i1;
  FILE *f;
  char fname[600];
  int cellstillexists;

  if(first_time==0)//initialisation
    {
      memid=-1;
      for(i1=0;i1<3000;i1++)
	{
	  trackcelllistPL[i1]=NULL;
	  trackcellidlistPL[i1]=-1;
	}

      first_time=1;
      idcounter=0;
    }
  else//the real stuff
    {
      c=CellGrid[periL_i][periL_j];
      if(c!=NULL && c->cellid!=memid)//new cell arrived!
	{
	  memid=c->cellid;
	  idcounter++;//THIS MEANS STORAGE IS FROM POSITION 1 ONWARDS
	  trackcelllistPL[idcounter]=c;//store pointer to cell
	  trackcellidlistPL[idcounter]=c->cellid;//store cell id

	  //printf("found cell %i\n",c->cellid);
	}
      if(idcounter>=3000)
	printf("idcounter is larger then 3000, array overflow!\n");


      //COULD THIS SOMEHOW GO WRONG BY DOING IT ONLY EVEREY 300TH STEP????
      if(time%300==0 && idcounter>0)//each 300th timestep, starting once a first cell is found
	{
	  for(i1=1;i1<=min(idcounter,2999);i1++)//for each cell thusfar found at end MZ
	    {
	      cellstillexists=0;//find if that cell still exists
	      it1=CellList->begin();
	      while(it1!=CellList->end())//loop over cell list
		{
		  c=(*it1);
		  if(c->cellid==trackcellidlistPL[i1])//cell with this id still exists
		    {
		      cellstillexists=1;
		      break;
		    }
		  it1++;
		}
	      if(cellstillexists==1)//if cell still exists
		{
		  c=trackcelllistPL[i1];//access the cell
		  sprintf(fname,"%s/TrackCellPeriLeft_%d",dirname,i1);//writing in unique file per cell
		  f=fopen(fname,"a");
		  //write time, auxin, Aux1, diff status, cell height, cell j position,
		  fprintf(f,"%f\t%f\t%f\t%f\t%i\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\n",(time/3600.0),c->MeanCells,c->Aux1, c->PP, c->CellHeight,c->Diff,(0.5*(c->CellMinJ+c->CellMaxJ)),c->memARF,c->memARFtot,c->Pin,c->AuxinSign,c->CumAuxin,c->AHP6,c->CKlevel,c->CKmean,c->CKsignal,c->pindown,c->pinup,c->pinin,c->epiO,c->Yuc3,c->Lax3);//,c->Lec2,c->Fus3,c->Yucca4);
		  fclose(f);
		}
	    }
	}
    }
#endif
}

//JT_trackingCells
//JT_LFYfeedback
void Tissue::TrackCellsPeriRight(int time)
{
#ifndef DEBUGMODE
  BCell *c;
  iter it2;
  static int first_time2=0;
  static int periR_i=n-1-(disttoepi+totsizeepi+totsizeendo+totsizecort+1);
#ifdef TRACKPRIMING
  static int periR_j=yLRC1-5*HMZ-5-1;
#endif
#ifdef TRACKGROWTH
  static int periR_j=yLRC1-30*HMZ-30-1;
#endif
  int i2;
  FILE *f;
  char fname[600];
  int cellstillexists2;

  if(first_time2==0)//initialisation
    {
      memid2=-1;
      for(i2=0;i2<3000;i2++)
	{
	  trackcelllistPR[i2]=NULL;
	  trackcellidlistPR[i2]=-1;
	}

      first_time2=1;
      idcounter2=0;
    }
  else//the real stuff
    {
      c=CellGrid[periR_i][periR_j];
      if(c!=NULL && c->cellid!=memid2)//new cell arrived!
	{
	  memid2=c->cellid;
	  idcounter2++;
	  trackcelllistPR[idcounter2]=c;//store pointer to cell
	  trackcellidlistPR[idcounter2]=c->cellid;//store cell id

	  //printf("found cell %i\n",c->cellid);
	}
      if(idcounter2>=3000)
	printf("idcounter2 is larger then 3000, array overflow!\n");


      if(time%300==0 && idcounter2>0)//each 100th timestep, starting once a first cell is found
	{
	  for(i2=1;i2<=min(idcounter2,2999);i2++)//for each cell thusfar found at end MZ
	    {
	      cellstillexists2=0;//find if that cell still exists
	      it2=CellList->begin();
	      while(it2!=CellList->end())//loop over cell list
		{
		  c=(*it2);
		  if(c->cellid==trackcellidlistPR[i2])//cell with this id still exists
		    {
		      cellstillexists2=1;
		      break;
		    }
		  it2++;
		}
	      if(cellstillexists2==1)//if cell still exists
		{
		  c=trackcelllistPR[i2];//access the cell
		  sprintf(fname,"%s/TrackCellPeriRight_%d",dirname,i2);//writing in unique file per cell
		  f=fopen(fname,"a");
		  //write time, auxin, Aux1, diff status, cell height, cell j position,
		  fprintf(f,"%f\t%f\t%f\t%f\t%i\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\n",(time/3600.0),c->MeanCells,c->Aux1, c->PP, c->CellHeight,c->Diff,(0.5*(c->CellMinJ+c->CellMaxJ)),c->memARF,c->memARFtot,c->Pin,c->AuxinSign,c->CumAuxin,c->AHP6,c->CKlevel,c->CKmean,c->CKsignal,c->pindown,c->pinup,c->pinin,c->epiO,c->Yuc3,c->Lax3);//,c->Lec2,c->Fus3,c->Yucca4);
		  fclose(f);
		}
	    }
	}
    }
#endif
}

//JT_trackingCells
//JT_LFYfeedback
void Tissue::TrackCellsVascLeft(int time)
{
#ifndef DEBUGMODE
  BCell *c;
  iter it3;
  static int first_time3=0;
  static int vascL_i=disttoepi+totsizeepi+totsizeendo+totsizecort+totsizeperi+1;
#ifdef TRACKPRIMING
  static int vascL_j=yLRC1-5*HMZ-5-1;
#endif
#ifdef TRACKGROWTH
  static int vascL_j=yLRC1-30*HMZ-30-1;
#endif
  int i3;
  FILE *f;
  char fname[600];
  int cellstillexists3;

  if(first_time3==0)//initialisation
    {
      memid3=-1;
      for(i3=0;i3<3000;i3++)
	{
	  trackcelllistVL[i3]=NULL;
	  trackcellidlistVL[i3]=-1;
	}

      first_time3=1;
      idcounter3=0;
    }
  else//the real stuff
    {
      c=CellGrid[vascL_i][vascL_j];
      if(c!=NULL && c->cellid!=memid3)//new cell arrived!
	{
	  memid3=c->cellid;
	  idcounter3++;
	  trackcelllistVL[idcounter3]=c;//store pointer to cell
	  trackcellidlistVL[idcounter3]=c->cellid;//store cell id

	  //printf("found cell %i\n",c->cellid);
	}
      if(idcounter3>=3000)
	printf("idcounter3 is larger then 3000, array overflow!\n");


      if(time%300==0 && idcounter3>0)//each 100th timestep, starting once a first cell is found
	{
	  for(i3=1;i3<=min(idcounter3,2999);i3++)//for each cell thusfar found at end MZ
	    {
	      cellstillexists3=0;//find if that cell still exists
	      it3=CellList->begin();
	      while(it3!=CellList->end())//loop over cell list
		{
		  c=(*it3);
		  if(c->cellid==trackcellidlistVL[i3])//cell with this id still exists
		    {
		      cellstillexists3=1;
		      break;
		    }
		  it3++;
		}
	      if(cellstillexists3==1)//if cell still exists
		{
		  c=trackcelllistVL[i3];//access the cell
		  sprintf(fname,"%s/TrackCellVascLeft_%d",dirname,i3);//writing in unique file per cell
		  f=fopen(fname,"a");
		  //write time, auxin, Aux1, diff status, cell height, cell j position,
		  fprintf(f,"%f\t%f\t%f\t%f\t%i\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\n",(time/3600.0),c->MeanCells,c->Aux1, c->PP, c->CellHeight,c->Diff,(0.5*(c->CellMinJ+c->CellMaxJ)),c->memARF,c->memARFtot,c->Pin,c->AuxinSign,c->CumAuxin,c->AHP6,c->CKlevel,c->CKmean,c->CKsignal,c->pindown,c->pinup,c->pinin,c->epiO,c->Yuc3,c->Lax3);//,c->Lec2,c->Fus3,c->Yucca4)
		  fclose(f);
		}
	    }
	}
    }
#endif
}

//JT_trackingCells
//JT_LFYfeedback
void Tissue::TrackCellsVascRight(int time)
{
#ifndef DEBUGMODE
  BCell *c;
  iter it4;
  static int first_time4=0;
  static int vascR_i=n-1-(disttoepi+totsizeepi+totsizeendo+totsizecort+totsizeperi+1);
#ifdef TRACKPRIMING 
  static int vascR_j=yLRC1-5*HMZ-5-1;
#endif
#ifdef TRACKGROWTH
  static int vascR_j=yLRC1-30*HMZ-30-1;
#endif
  int i4;
  FILE *f;
  char fname[600];
  int cellstillexists4;

  if(first_time4==0)//initialisation
    {
      memid4=-1;
      for(i4=0;i4<3000;i4++)
	{
	  trackcelllistVR[i4]=NULL;
	  trackcellidlistVR[i4]=-1;
	}

      first_time4=1;
      idcounter4=0;
    }
  else//the real stuff
    {
      c=CellGrid[vascR_i][vascR_j];
      if(c!=NULL && c->cellid!=memid4)//new cell arrived!
	{
	  memid4=c->cellid;
	  idcounter4++;
	  trackcelllistVR[idcounter4]=c;//store pointer to cell
	  trackcellidlistVR[idcounter4]=c->cellid;//store cell id

	  //printf("found cell %i\n",c->cellid);
	}
      if(idcounter4>=3000)
	printf("idcounter4 is larger then 3000, array overflow!\n");


      if(time%300==0 && idcounter4>0)//each 100th timestep, starting once a first cell is found
	{
	  for(i4=1;i4<=min(idcounter4,2999);i4++)//for each cell thusfar found at end MZ
	    {
	      cellstillexists4=0;//find if that cell still exists
	      it4=CellList->begin();
	      while(it4!=CellList->end())//loop over cell list
		{
		  c=(*it4);
		  if(c->cellid==trackcellidlistVR[i4])//cell with this id still exists
		    {
		      cellstillexists4=1;
		      break;
		    }
		  it4++;
		}
	      if(cellstillexists4==1)//if cell still exists
		{
		  c=trackcelllistVR[i4];//access the cell
		  sprintf(fname,"%s/TrackCellVascRight_%d",dirname,i4);//writing in unique file per cell
		  f=fopen(fname,"a");
		  //write time, auxin, Aux1, diff status, cell height, cell j position,
		   fprintf(f,"%f\t%f\t%f\t%f\t%i\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\n",(time/3600.0),c->MeanCells,c->Aux1, c->PP, c->CellHeight,c->Diff,(0.5*(c->CellMinJ+c->CellMaxJ)),c->memARF,c->memARFtot,c->Pin,c->AuxinSign,c->CumAuxin,c->AHP6,c->CKlevel,c->CKmean,c->CKsignal,c->pindown,c->pinup,c->pinin,c->epiO,c->Yuc3,c->Lax3);//,c->Lec2,c->Fus3,c->Yucca4)
		  fclose(f);
		}
	    }
	}
    }
#endif
}




void Tissue::SaveTemp(int t,int II,int JJ)
{
  FILE *f;
  char s[1000];
  BCell *c;

  if(CellGrid[II][JJ]!=NULL)
    {
      c=CellGrid[II][JJ];
      sprintf(s,"%s/TemporalDynamicsPoint%i_%i",dirname,II,JJ);
      f=fopen(s,"a");
      fprintf(f,"%i\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\n",t,c->MeanCells,c->ARF,c->AA,c->BB,c->CC,c->DD,c->Plts,c->Pltsexpr,c->Diff);
      fclose(f);
    }
}

void Tissue::SaveGradCellularRes(int t)
{
  FILE *g;
  int i,ii,j;
  BCell *c;
  char s[1000];

  for(int k=0;k<8;k++)
    {
      if(k==0)
	{
	  //left epidermis
	  i=disttoepi+0.5*totsizeepi;
	  sprintf(s,"%s/Spatialdynamics_epiL_time%i",dirname,t);
	}
      else if(k==1)
	{
	  ;
#ifdef SYMMETRYBREAKING
	  //right epidermis
	  ii=disttoepi+0.5*totsizeepi;
	  i=n-1-ii;
	  sprintf(s,"%s/Spatialdynamics_epiR_time%i",dirname,t);
#endif
	}
      else if(k==2)
	{
	  //left cortex
	  i=disttoepi+totsizeepi+0.5*totsizecort;
	  sprintf(s,"%s/Spatialdynamics_cortexL_time%i",dirname,t);
	}
      else if(k==3)
	{
	  ;
#ifdef SYMMETRYBREAKING
	  //right cort
	  ii=disttoepi+totsizeepi+0.5*totsizecort;
	  i=n-1-ii;
	  sprintf(s,"%s/Spatialdynamics_cortexR_time%i",dirname,t);
#endif
	}
      else if(k==4)
	{
	  //left endodermis
	  i=disttoepi+totsizeepi+totsizecort+0.5*totsizeendo;
	  sprintf(s,"%s/Spatialdynamics_endoL_time%i",dirname,t);
	}
      else if(k==5)
	{
	  ;
#ifdef SYMMETRYBREAKING
	  //right endodermis
	  ii=disttoepi+totsizeepi+totsizecort+0.5*totsizeendo;
	  i=n-1-ii;
	  sprintf(s,"%s/Spatialdynamics_endoR_time%i",dirname,t);
#endif
	}
      else if(k==6)
	{
	  //left vasculature
	  i=disttoepi+totsizeepi+totsizecort+totsizeendo+totsizeperi+0.3*totsizevasc;
	  sprintf(s,"%s/Spatialdynamics_vascL_time%i",dirname,t);
	}
      else if(k==7)
	{
	  ;
#ifdef SYMMETRYBREAKING
	  //right vasculature
	  ii=disttoepi+totsizeepi+totsizecort+totsizeendo+totsizeperi+0.3*totsizevasc;
	  i=n-1-i;
	  sprintf(s,"%s/Spatialdynamics_vascR_time%i",dirname,t);
#endif
	}

      if(k%2==1)
	{
	  g=fopen(s,"wb");
	  for(j=0;j<m;j++)
	    {
	      if(CellGrid[i][j]!=NULL)
		{
		  c=CellGrid[i][j];
		  fprintf(g,"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%i\n",j,c->MeanCells,c->ARF,c->AA,c->BB,c->CC,c->DD,c->Plts,c->Pltsexpr,c->Diff,c->CellHeight);
		}
	      else if(Tc[i][j]==3)
		fprintf(g,"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%i\n",j,-10.0,-10.0,-10.0,-10.0,-10,-10.0,-10.0,-10.0,-10.0,-10);
	    }
	  fclose(g);
	}
	
#ifdef SYMMETRYBREAKING
      if(k%2==0)
	{
	  g=fopen(s,"wb");
	  for(j=0;j<m;j++)
	    {
	      if(CellGrid[i][j]!=NULL)
		{
		  c=CellGrid[i][j];
		  fprintf(g,"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%i\n",j,c->MeanCells,c->ARF,c->AA,c->BB,c->CC,c->DD,c->Plts,c->Pltsexpr,c->Diff,c->CellHeight);
		}
	      else if(Tc[i][j]==3)
		fprintf(g,"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%i\n",j,-10.0,-10.0,-10.0,-10.0,-10,-10.0,-10.0,-10.0,-10.0,-10);
	    }
	  fclose(g);
	}
#endif
	
    }
}

void Tissue::SaveGradGridRes(int time)
{
  FILE *ff1;
  FILE *ff2;
  char s1[900];
  char s2[900];
  int i,ii,j,k;
  int List[8]={1,5,6,7,8,100,100,100};

  for(k=0;k<8;k++)
    {
      if(k==0)
	{
	  sprintf(s1,"%s/GridResolutionL_RC1_time%i",dirname,time);
	  sprintf(s2,"%s/GridResolutionR_RC1_time%i",dirname,time);
	}
      if(k==1)
	{
	  sprintf(s1,"%s/GridResolutionL_Epi_time%i",dirname,time);
	  sprintf(s2,"%s/GridResolutionR_Epi_time%i",dirname,time);

	}
      if(k==2)
	{
	  sprintf(s1,"%s/GridResolutionL_Cort_time%i",dirname,time);
	  sprintf(s2,"%s/GridResolutionR_Cort_time%i",dirname,time);

	}
      if(k==3)
	{
	  sprintf(s1,"%s/GridResolutionL_Endo_time%i",dirname,time);
	  sprintf(s2,"%s/GridResolutionR_Endo_time%i",dirname,time);

	}
      if(k==4)
	{
	  sprintf(s1,"%s/GridResolutionL_Peri_time%i",dirname,time);
	  sprintf(s2,"%s/GridResolutionR_Peri_time%i",dirname,time);

	}
      if(k==5)
	{
	  sprintf(s1,"%s/GridResolutionL_Vasc1_time%i",dirname,time);
	  sprintf(s2,"%s/GridResolutionR_Vasc1_time%i",dirname,time);

	}
      if(k==6)
	{
	  sprintf(s1,"%s/GridResolutionL_Vasc2_time%i",dirname,time);
	  sprintf(s2,"%s/GridResolutionR_Vasc2_time%i",dirname,time);

	}
      if(k==7)
	{
	  sprintf(s1,"%s/GridResolutionL_Vasc3_time%i",dirname,time);
	  sprintf(s2,"%s/GridResolutionR_Vasc3_time%i",dirname,time);

	}




      ff1=fopen(s1,"w");
      ff2=fopen(s2,"w");


      /*
      for(j=0;j< yLRCstraight;j++)//special treatment for curved part
	{

	  i=0;

	  while(Tct[i][j]!=List[k]  && i<xm)//find position of right cell type
	    i++;

	  if(Tct[i][j]==List[k])
	    {
	      i++;
	      ii=n-(1+i);

	      if(CellGrid[i][j]!=NULL)
		{
		  fprintf(ff1,"%i\t%i\t%f\t%f\t%f\n",i,j,Caux1[i][j],Cpin1M[i][j], Aux1M[i][j]);
		  fprintf(ff2,"%i\t%i\t%f\t%f\t%f\n",ii,j,Caux1[ii][j],Cpin1M[ii][j], Aux1M[ii][j]);
		}
	    }
	    }*/

      for(j=yLRCstraight;j<yEND;j++)//for(j= yQC;j<yEND;j++)//yLRCstraight
	{
	  if(k==0)
	    i=1;
	  else if(k==1)
	    i=disttoepi+1;
	  else if(k==2)
	    i=totsizeepi+disttoepi+1;
	  else if(k==3)
	    i=totsizecort+totsizeepi+disttoepi+1;
	  else if(k==4)
	    i=totsizeendo+totsizecort+totsizeepi+disttoepi+1;
	  else if(k==5)
	    i=totsizeperi+totsizeendo+totsizecort+totsizeepi+disttoepi+1;
	  else if(k==6)
	    i=sizevasc+totsizeperi+totsizeendo+totsizecort+totsizeepi+disttoepi+1;
	  else if(k==7)
	    i=xm-1;//2*sizevasc+totsizeperi+totsizeendo+totsizecort+totsizeepi+disttoepi+1;

	  ii=n-(1+i);
	  if(CellGrid[i][j]!=NULL)
	    {
	      fprintf(ff1,"%i\t%i\t%f\t%f\t%f\n",i,j,Caux1[i][j],Cpin1M[i][j], Aux1M[i][j]);
	      fprintf(ff2,"%i\t%i\t%f\t%f\t%f\n",ii,j,Caux1[ii][j],Cpin1M[ii][j], Aux1M[ii][j]);
	    }
	}

      fclose(ff1);
      fclose(ff2);

    }
 }

 void Tissue::TrackWallsSpaceTime(int t, int starttime)
 {
   FILE *f1, *f2, *f3;
   int i,ii,iii, j,jj,jjj, x, start;
   //char s1[1000];
   char s2[1000];
   //char s3[1000];
   BCell *c;
   
   start = starttime;
   int restart_time;
   restart_time = t - start;
   
   i=disttoepi+1;
   ii=totsizeendo+totsizecort+totsizeepi+disttoepi+1;
   iii=totsizeperi+totsizeendo+totsizecort+totsizeepi+disttoepi+1;
   //sprintf(s1,"%s/TrackAuxinFluxEpiSpaceTime",dirname);
   sprintf(s2,"%s/TrackAuxinFluxPeriSpaceTime",dirname);
   //sprintf(s3,"%s/TrackAuxinFluxVascSpaceTime",dirname);
   //f1=fopen(s1, "a");
   f2=fopen(s2, "a");
   //f3=fopen(s3, "a");
   
   
   for(j=yLRCstraight; j<yLRC1+10*HEZ+18*HDZ+29; j++)
     {
       
       //epi
       /*
       if(CellGrid[i][j]!=NULL)
	 {
	   c=CellGrid[i][j];
	   fprintf(f1, "%i\t%i\t%f\t%i\t%i\n", t, j, c->AuxinSign, c->CellHeight, c->cellid);
	 }
       else
	 {
	   fprintf(f1,  "%i\t%i\t%f\t%i\t%i\n", t,j,0.0,0,0);
	 }
       */
       //peri
       if(CellGrid[ii][j]!=NULL)
	 {
	   c=CellGrid[ii][j];
	   fprintf(f2, "%i\t%i\t%f\t%i\t%i\n", t, j, c->AuxinSign, c->CellHeight, c->cellid);
	 }
       else
	 {
	   fprintf(f2,  "%i\t%i\t%f\t%i\t%i\n", t,j,0.0,0,0);
	   
	 }
       
       //vasc
       /*
       if(CellGrid[iii][j]!=NULL)
	 {
	 
	   c=CellGrid[iii][j];
	   fprintf(f3, "%i\t%i\t%f\t%i\t%i\n", t, j, c->AuxinSign, c->CellHeight, c->cellid);
	 }
       else
	 {
	   fprintf(f3,  "%i\t%i\t%f\t%i\t%i\n", t,j,0.0,0,0);
	 }
       */

     }
   //fprintf(f1,"\n");
   fprintf(f2,"\n");
   //fprintf(f3,"\n");
   //fclose(f1);
   fclose(f2);
   //fclose(f3);

}
