#include "Tissue.hh"

#include "BCell.hh"

Tissue::Tissue()
{
  CellList=NULL;
  actcells=0;
  maxidnr=0;

  //for(int i=0;i<3000;i++)
    //trackcelllist[i]=NULL;

    //JT_trackingCells
  for(int i=0;i<3000;i++)
    trackcelllistPL[i]=NULL;

    for(int i=0;i<3000;i++)
      trackcelllistPR[i]=NULL;

      for(int i=0;i<3000;i++)
        trackcelllistVL[i]=NULL;

        for(int i=0;i<3000;i++)
          trackcelllistVR[i]=NULL;
}

Tissue::~Tissue()
{
  iter i;

  //for(int i=0;i<3000;i++)
    //trackcelllist[i]=NULL;

    //JT_trackingCells
  for(int i=0;i<3000;i++)
    trackcelllistPL[i]=NULL;

    for(int i=0;i<3000;i++)
      trackcelllistPR[i]=NULL;

      for(int i=0;i<3000;i++)
        trackcelllistVL[i]=NULL;

        for(int i=0;i<3000;i++)
          trackcelllistVR[i]=NULL;

  if(CellList!=NULL)
    {
      i=CellList->begin();
      while(i!=CellList->end())
	{
	  delete (*i);
	  i++;
	}
      i=CellList->erase(CellList->begin(),CellList->end());
      delete CellList;
      CellList=NULL;
    }
}


void Tissue::SetUpTissueLayout()
{
  int i,j,k,l,ii;
  /*****************************************************************/


  //in Tc[n][m]
  //0 = wall
  //1 = cell
  //2 = membrane
  //3 = non-tissue

  //in Tct[n][m]
  //0 = no cell
  //1 = lateral root cap 1
  //2 = lateral root cap 2
  //3 = lateral root cap 3
  //4 = lateral root cap 4
  //5 = epi
  //6 = cort
  //7 = endo
  //8 = peri
  //9 = vasc 1
  //10 = vasc 2
  //11 = vasc 3
  //12 = QC
  //13 = columella 1
  //14 = columella 2
  //15 = columella 3
  //16 = columella 4
  //17 = columella 5
  //18 = columella initials

  /******************************************************************/

  //0: Initially put all to non-tissue, no cell
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
	Tc[i][j]=3;
	Tct[i][j]=0;
      }

  //1: Now, set up where there is plant tissue and where not
  //Step a: generate straight part of tissue without root cap
  for(i=xm;i>=disttoepi ;i--)
    for(j=yLRC1;j<yEND;j++)
      {
	ii=n-1-i;
	Tc[i][j]=1;//make all cell, walls and membranes done later
	Tc[ii][j]=1;
	Tct[i][j]=5;//make all epidermal, other types done later
	Tct[ii][j]=5;
      }
  //Step b: generate straigth part of tissue with root cap
  for(i=xm;i>=disttolrc;i--)
    for(j=yLRCstraight;j<=yLRC1;j++)
      {
	ii=n-1-i;
	Tc[i][j]=1;
	Tc[ii][j]=1;
	Tct[i][j]=5;
	Tct[ii][j]=5;
      }

  //Step c: generate curved part of tissue with root cap
  //for this use parabola describing the outer boundary of
  //the outermost root cap layer LRC1
  for(i=xm;i>=0;i--)
    for(j=yzero;j<=yLRCstraight;j++)
      {
 	ii=n-1-i;
	if(j>=(int)(aLRC1*abs(pow((i-xm),powLRC1))+bLRC1))
	  {
	    Tc[i][j]=1;//make all cell, walls and membranes done later
	    Tc[ii][j]=1;
	    Tct[i][j]=1;//make all lateral root cap type, other types done later
	    Tct[ii][j]=1;
	  }
      }
  /************************************************************/

  //2: Next, setup where is cell wall and where are different cell types
  int temp;
  double iii,jjj;
  int I;

  //Step a: in straight part of tissue without root cap
  //vertical walls & celltypes
  for(j=yLRC1;j<yEND;j++)
    {
      //set leftmost cell wall
      i=disttoepi;
      //set rightmost cell wall
      ii=n-1-i;
      Tc[i][j]=0;
      Tc[ii][j]=0;

      //start in the middle
      i=xm;
      //set middlemost wall
      Tc[i][j]=0;
      //go over the total nr of cells of epi, cort, endo, peri and vasc type
      for(k=0;k<nrepi+nrcort+nrendo+nrperi+nrvasc;k++)
	{
	  if(k<nrvasc)//cell of vasc type
	    {
	      //subdivide later 9-10-11
	      for(I=i;I>=i-(sizevasc+1);I--)//go over cell, inside out, assign type
		{

		  Tct[I][j]=9;
		  Tct[n-1-I][j]=9;
		}
	      //for assigning walls in between cells
	      i-=sizevasc+1;
	    }
	  else if(k<nrvasc+nrperi)
	    {
	      for(I=i;I>=i-(sizeperi+1);I--)
		{
		  Tct[I][j]=8;
		  Tct[n-1-I][j]=8;
		}
	      i-=sizeperi+1;
	    }
	  else if(k<nrvasc+nrperi+nrendo)
	    {
	      for(I=i;I>=i-(sizeendo+1);I--)
		{
		  Tct[I][j]=7;
		  Tct[n-1-I][j]=7;
		}
	      i-=sizeendo+1;
	    }
	  else if(k<nrvasc+nrperi+nrendo+nrcort)
	    {
	      for(I=i;I>=i-(sizecort+1);I--)
		{
		  Tct[I][j]=6;
		  Tct[n-1-I][j]=6;
		}
	      i-=sizecort+1;
	    }
	  else if(k<nrvasc+nrperi+nrendo+nrcort+nrepi)
	    i-=sizeepi+1;
	
	  Tc[i][j]=0;
	  ii=n-1-i;
	  Tc[ii][j]=0;	 
	}
    }
  //Step b: straight part of tissue with root cap
  //walls and celltypes
  for(j=yLRCstraight;j<=yLRC1;j++)
    {
      //similar to above but with rootcap


      //set leftmost cell wall
      i=disttolrc;
      //set rightmost cell wall
      ii=n-1-i;
      Tc[i][j]=0;
      Tc[ii][j]=0;


      //middlemost wall
      i=xm;
      Tc[i][j]=0;


      //the presence of the lrc is in the +1
      for(k=0;k<nrepi+nrcort+nrendo+nrperi+nrvasc+1;k++)
	{
	  if(k<nrvasc)
	    {
	      //subdivide later 9-10-11
	      for(I=i;I>=i-(sizevasc+1);I--)//!
		{
		  Tct[I][j]=9;
		  Tct[n-1-I][j]=9;
		}
	      i-=sizevasc+1; //!
	    }
	  else if(k<nrvasc+nrperi)
	    {
	      for(I=i;I>=i-(sizeperi+1);I--)//!
		{
		  Tct[I][j]=8;
		  Tct[n-1-I][j]=8;
		}
	      i-=sizeperi+1;
	    }
	  else if(k<nrvasc+nrperi+nrendo)
	    {
	      for(I=i;I>=i-(sizeendo+1);I--)//!
		{
		  Tct[I][j]=7;
		  Tct[n-1-I][j]=7;
		}
	      i-=sizeendo+1;
	    }
	  else if(k<nrvasc+nrperi+nrendo+nrcort)
	    {
	      for(I=i;I>=i-(sizecort+1);I--)//!
		{
		  Tct[I][j]=6;
		  Tct[n-1-I][j]=6;
		}
	      i-=sizecort+1;
	    }
	  else if(k<nrvasc+nrperi+nrendo+nrcort+nrepi)
	    i-=sizeepi+1;//!
	  else if(k<nrvasc+nrperi+nrendo+nrcort+nrepi+1)//!
	    {
	      //lrc1
	      for(I=i;I>=i-(sizetoplrc);I--)
		{
		  Tct[I][j]=1;
		  Tct[n-1-I][j]=1;
		}
	      i-=sizetoplrc;
	    }
#ifdef NORMALTISSUEPATTERN
	  Tc[i][j]=0;
	  ii=n-1-i;
	  Tc[ii][j]=0;
#endif
#ifdef SKEWEDTISSUEPATTERN
	  if(k>=nrvasc-1 || j>yLRCstraight+2)
	    {
	      Tc[i][j]=0;
	      ii=n-1-i;
	      Tc[ii][j]=0;
	    }
#endif
	}
    }

  //Step c: in curved part of tissue with root cap
  //semi-vertical lines (parabola) & celltypes
  //first walls
  for(i=xm;i>=0;i--)
    for(j=yzero;j<=yLRCstraight;j++)
      {
	ii=n-1-i;
	if(Tc[i][j]!=3)
	  {
	    if(j==(int)(aVASC*abs(pow((i-xm),powVASC))+bVASC) ||
	       i==n-1-(int)(pow(((j-bVASC)/aVASC),(1.0/powVASC))+xm))//MAYBE NOT TILL END
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	    else if(j==(int)(aPERI*abs(pow((i-xm),powPERI))+bPERI) ||
		    i==n-1-(int)(pow(((j-bPERI)/aPERI),(1.0/powPERI))+xm))
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	    else if(j==(int)(aENDO*abs(pow((i-xm),powENDO))+bENDO) ||
		    i==n-1-(int)(pow(((j-bENDO)/aENDO),(1.0/powENDO))+xm))
	      {
		if(j>(int)(arad3*i+brad3))//if(j>(int)(arad4*i+brad4))
		  {
		    Tc[i][j]=0;
		    Tc[ii][j]=0;
		  }
	      }
	    else if(j==(int)(aCORT*abs(pow((i-xm),powCORT))+bCORT) ||
		    i==n-1-(int)(pow(((j-bCORT)/aCORT),(1.0/powCORT))+xm))
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	    else if(j==(int)(aEPI*abs(pow((i-xm),powEPI))+bEPI)||
		    i==n-1-(int)(pow(((j-bEPI)/aEPI),(1.0/powEPI))+xm))
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	    else if(j<yLRC4 && (j==(int)(aLRC4*abs(pow((i-xm),powLRC4))+bLRC4) ||
				i==n-1-(int)(pow(((j-bLRC4)/aLRC4),(1.0/powLRC4))+xm)) )
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	    else if(j<yLRC3 && (j==(int)(aLRC3*abs(pow((i-xm),powLRC3))+bLRC3) ||
				i==n-1-(int)(pow(((j-bLRC3)/aLRC3),(1.0/powLRC3))+xm)) )
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	    else if(j<yLRC2 && (j==(int)(aLRC2*abs(pow((i-xm),powLRC2))+bLRC2) ||
				i==n-1-(int)(pow(((j-bLRC2)/aLRC2),(1.0/powLRC2))+xm)) )
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	    else if(j==(int)(aLRC1*abs(pow((i-xm),powLRC1))+bLRC1) ||
		    i==n-1-(int)(pow(((j-bLRC1)/aLRC1),(1.0/powLRC1))+xm))
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	  }
      }
  //then celltypes
  for(i=xm;i>=0;i--)
    for(j=0;j<yLRCstraight;j++) //!j=0;j<yLRC1-18*M1-2;j++
      {
	if(Tc[i][j]!=3)
	  {
	    ii=n-1-i;
	    //parabola like curves

	    //met de power 5 gaat er nog wat mis met celltypes
	    //opgelost met i>60, niet echt mooi


	    //subdivide later 9-10-11
	    if(i>(60/xstep) && j>=(int)(aVASC*abs(pow((i-xm),powVASC))+bVASC)) //!60
	      {
		Tct[i][j]=9;
		Tct[ii][j]=9;
	      }
	    else if(i>(60/xstep) && j>=(int)(aPERI*abs(pow((i-xm),powPERI))+bPERI))
	      {
		Tct[i][j]=8;
		Tct[ii][j]=8;
	      }
	    else if(j>=(int)(aENDO*abs(pow((i-xm),powENDO))+bENDO))
	      {
		Tct[i][j]=7;
		Tct[ii][j]=7;
	      }
	    else if(j>=(int)(aCORT*abs(pow((i-xm),powCORT))+bCORT))
	      {
		Tct[i][j]=6;
		Tct[ii][j]=6;
	      }
	    else if(j>=(int)(aEPI*abs(pow((i-xm),powEPI))+bEPI) )
	      {
		Tct[i][j]=5;
		Tct[ii][j]=5;
	      }
	    else if(j<(int)(arad2*i+brad2) && j>=(int)(aLRC4*abs(pow((i-xm),powLRC4))+bLRC4))
	      {
		Tct[i][j]=4;
		Tct[ii][j]=4;
	      }
	    else if(j<yLRC3 && j>=(int)(aLRC3*abs(pow((i-xm),powLRC3))+bLRC3))
	      {
		Tct[i][j]=3;
		Tct[ii][j]=3;
	      }
	    else if(j<yLRC2 && j>=(int)(aLRC2*abs(pow((i-xm),powLRC2))+bLRC2))
	      {
		Tct[i][j]=2;
		Tct[ii][j]=2;
	      }
	  }
      }
  //some more celltypes
  //QC and columella
  for(i=xm;i>=0;i--)
     for(j=yzero;j<yLRCstraight;j++)
       {
	 ii=n-1-i;
	 if(Tc[i][j]!=3)
	   {
	     //different collumella layers
	     if(Tct[i][j]==1 && j<(int)(arad3*i+brad3))//LRC1,2,3,4,of epi
	       {
		 Tct[i][j]=13;
		 Tct[ii][j]=13;
	       }
	     else if(Tct[i][j]==2 && j<(int)(arad3*i+brad3))//LRC1,2,3,4,of epi
	       {
		 Tct[i][j]=14;
		 Tct[ii][j]=14;
	       }
	     else if(Tct[i][j]==3 && j<(int)(arad3*i+brad3))//LRC1,2,3,4,of epi
	       {
		 Tct[i][j]=15;
		 Tct[ii][j]=15;
	       }
	     else if(Tct[i][j]==4 && j<(int)(arad3*i+brad3))//LRC1,2,3,4,of epi
	       {
		 Tct[i][j]=16;
		 Tct[ii][j]=16;
	       }
	     else if(Tct[i][j]==5 && j<(int)(arad3*i+brad3))//LRC1,2,3,4,of epi
	       {
		 Tct[i][j]=17;
		 Tct[ii][j]=17;

		 //zou evt opgesplitst in laag 15 en laag 16 moeten worden
	       }

	     //QC
	     if((Tct[i][j]==6 || Tct[i][j]==7) && j<(int)(arad4*i+brad4))//cortex -> QC
	       {
		 Tct[i][j]=12;
		 Tct[ii][j]=12;
	       }
	   }
       }
  //above yR vertical lines inside vasculature
  //reducing nr of vasc cells to prevent narrowness
   for(j=yR;j<=yLRCstraight;j++)
    {
      //middle wall aligned with rest of tissue
      i=xm;
      Tc[i][j]=0;
      for(k=0;k<nrvasc-1;k++)//nr cell files in vasc -1, outer wall given by parabola
	{

	  i-=sizevasc;
	  Tc[i][j]=0;
	  ii=n-1-i;
	  Tc[ii][j]=0;
	}
    }
  //below yR, so from yQC onward, inside peri parabola
  //vertical lines for vasculature, reducing nr of
  //vascular cell files to prevent to narrow cells
  for(j=yQC+HMZ+1;j<yR;j++)
    {
      i=xm;
      i-=sizevasc+1;
      Tc[i][j]=0;
      ii=n-1-i;
      Tc[ii][j]=0;
    }

  /******************************************************************/

  //straight part of tissue with and without root cap
  //horizontal walls, different cellsizes (heights) in different zones
  for(i=xm;i>=disttolrc;i--)
    {
      ii=n-1-i;

#ifdef NORMALTISSUEPATTERN
      //bottommost one, first one of straight part
      j= yLRCstraight;
      if(Tc[i][j]!=3)
	{
	  Tc[i][j]=0;
	  Tc[ii][j]=0;
	}

      //then 15 walls at equal distances
      //generating equally sized MZ cell
      for(k=1;k<=nrcellsstraightMZ;k++ )//for(k=1;k<=15;k++ )
	{
#ifdef VASCDIFFERENT
	  if(Tct[i][j]<9 || Tct[i][j]>11)
#endif
	    j+=HMZ+1;
#ifdef VASCDIFFERENT
	  else//LARGER VASCULATURE
	    j+=1.5*HMZ+1;//LARGER VASCULATURE
	  if(j<yLRC1-1)//LARGER VASCULATURE
	    {//LARGER VASCULATURE
#endif
	  if(Tc[i][j]!=3)
	    {
	      //larger cells in lrc
	      if(Tct[i][j]==1)
		{
		  if(k==2 || k==5 || k==10 || k==16)
		    {
		      Tc[i][j]=0;
		      Tc[ii][j]=0;
		    }
		}
	      else
		{
		  Tc[i][j]=0;
		  Tc[ii][j]=0;
		}
	    }
#ifdef VASCDIFFERENT
	    }//LARGER VASCULATURE
#endif
	}
#endif
#ifdef SKEWEDTISSUEPATTERN
      //bottommost one, first one of straight part
      j= yLRCstraight;
      if(Tc[i][j]!=3)
	{
	  if(!(Tct[i][j]>=9 && Tct[i][j]<=11))
	    {
	      Tc[i][j]=0;
	      Tc[ii][j]=0;
	    }
	}
      int jj=j+2;
      if(Tc[i][jj]!=3)
	{
	  if(Tct[i][jj]>=9 && Tct[i][jj]<=11)
	    {
	      Tc[i][jj]=0;
	      Tc[ii][jj]=0;
	    }
	}
     
      //then 15 walls at equal distances
      //generating equally sized MZ cell
      for(k=1;k<=nrcellsstraightMZ;k++ )//for(k=1;k<=15;k++ )
	{
	  j+=HMZ+1;

	  if(Tc[i][j]!=3)
	    {
	      //larger cells in lrc
	      if(Tct[i][j]==1)
		{
		  if(k==2 || k==5 || k==10 || k==16)
		    {
		      Tc[i][j]=0;
		      Tc[ii][j]=0;
		    }
		}
	      else
		{
		  Tc[i][j]=0;
		  Tc[ii][j]=0;
		}
	    }
	}
      
#endif

      //then a wall to top off LRC, resulting
      //in slightly higher last MZ cell
      j=yLRC1;
      if(Tc[i][j]!=3)
	{
	  Tc[i][j]=0;
	  Tc[ii][j]=0;
	}


      //then gradually increasing cell sizes
      //as we go through EZ and end in DZ
      //WE HAVE AN EXTRA MYSTERY CELL WALL???
      for(k=1;k<=13;k++)
	{
	  if(k==1)
	    j+=24/xstep+1;
	  else if(k==2)
	    j+=26/xstep+1;
	  else if(k==3)
	    j+=30/xstep+1;
	  else if(k==4)
	    j+=36/xstep+1;
	  else if(k==5)
	    j+=44/xstep+1;
	  else if(k==6)
	    j+=54/xstep+1;
	  else if(k==7)
	    j+=66/xstep+1;
	  else if(k==8)
	    j+=80/xstep+1;
	  else
	    j+=108/xstep+1;

	  if(j<yEND && Tc[i][j]!=3)
	    {
	      Tc[i][j]=0;
	      Tc[ii][j]=0;
	    }
	}


      j=yEND-1;
      if(Tc[i][j]!=3)
	{
	  Tc[i][j]=0;
	  Tc[ii][j]=0;
	}

    }

  //in curved part of tissue with root cap
  //horizontal and radial lines
  //above yR horizontal lines
  for(i=xm;i>=0;i--)
    {
      ii=n-1-i;
      j=yR;

      //first horizontal line at j=yR
      /*if(Tc[i][j]!=3 )//OUTCOMMENTED FOR LARGER VASC
	{
	  Tc[i][j]=0;
	  Tc[ii][j]=0;
	  }*/

      //horizontal walls for MZ cells above yR in curved part
      /*for(k=1;k<=5;k++ )//for(k=1;k<=3;k++ )//OUTCOMMENTED FOR LARGER VASC
	{

	  j+=HMZ+1;
	  if(Tc[i][j]!=3 )
	    {
	      if(Tct[i][j]>2 || (k==2 || k==5))//k%2==0)//(k==1 || k%3==0))//larger cells in lrc
		{
		  Tc[i][j]=0;
		  Tc[ii][j]=0;
		}
	    }
	    }*/
    }

  //below yR, so from yQC onward, inside peri parabola
  //horizontal cell walls
  /*for(i=xm;i>=0;i--)//OUTCOMMENTED FOR LARGER VASC
    {
      ii=n-1-i;
      j=yQC;

      for(k=1;k<=5;k++ )//for(k=1;k<=3;k++ )
	{
	  j+=HMZ+1;
	  if(Tc[i][j]!=3 && (Tct[i][j]>=8 && Tct[i][j]<=11))
	    {
	      Tc[i][j]=0;
	      Tc[ii][j]=0;
	    }
	}
	}*/


  //below yR, inside LRC1 parabola
  //radial lines and vertical line in middle
  for(i=xm;i>=0;i--)
    for(j=yzero;j<yR;j++)
      {
	ii=n-1-i;

	if(j>yQC && j<yQC+HMZ+1)
	  {
	    if(i==(xm-(6/xstep)))
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	  }

	if(i==xm)
	  {
	    Tc[i][j]=0;
	    Tc[ii][j]=0;
	  }
	else if(j>=(int)(aLRC1*abs(pow((i-xm),powLRC1))+bLRC1))
	  {
	    if((j==(int)(arad1*i+brad1) || i==(int)((j-brad1)/arad1)) && Tct[i][j]<8)
	      {
		if(j<(int)(aENDO*abs(pow((i-xm),powENDO))+bENDO))
		  {
		    Tc[i][j]=0;
		    Tc[ii][j]=0;
		  }
	      }
	    else if((j==(int)(arad2*i+brad2) || i==(int)((j-brad2)/arad2)) && Tct[i][j]<8 )
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }

	    else if((j==(int)(arad3*i+brad3) || i==(int)((j-brad3)/arad3)) && Tct[i][j]<8 )
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }
	    else if((j==(int)(arad4*i+brad4) || i==(int)((j-brad4)/arad4)) && (Tct[i][j]<8 || Tct[i][j]>11))
	      {
		Tc[i][j]=0;
		Tc[ii][j]=0;
	      }

	    }
      }


  //New: ensure continuity in walls
  //diffusion is only with neighbours directly above, below, left or right
  //if a wall has points wich are only connected to other wall points via
  //"diagonal neighbours" (below and left eg) there is no diffusion between
  //these wall points and hence there is discontinuity
  for(i=xm;i>0;i--)
    for(j=0;j<m;j++)
      {
	ii=n-1-i;
	if(Tc[i][j]==0)//wall
	  {
	    //no direct upper down or left right neighbours also wall
	    if(!(Tc[i+1][j]==0 || Tc[i-1][j]==0 || Tc[i][j+1]==0 || Tc[i][j-1]==0))
	      {
		if(Tc[i+1][j+1]==0)
		  {
		    Tc[i+1][j]=0;
		    Tct[i+1][j]=0;
		    Tc[ii-1][j]=0;
		    Tct[ii-1][j]=0;
		  }
		else if(Tc[i+1][j-1]==0)
		  {
		    Tc[i+1][j]=0;
		    Tct[i+1][j]=0;
		    Tc[ii-1][j]=0;
		    Tct[ii-1][j]=0;
		  }
		else if(Tc[i-1][j+1]==0)
		  {
		    Tc[i-1][j]=0;
		    Tct[i-1][j]=0;
		    Tc[ii+1][j]=0;
		    Tct[ii+1][j]=0;
		  }
		else if(Tc[i-1][j-1]==0)
		  {
		    Tc[i-1][j]=0;
		    Tct[i-1][j]=0;
		    Tc[ii+1][j]=0;
		    Tct[ii+1][j]=0;
		  }
	      }
	  }
      }

  /************************************************************/
  //next setup membranes based on cell walls
  for(i=0;i<n;i++)
    for(j=yzero;j<yEND;j++)
      {
	if(Tc[i][j]==1)//cell
	  {
	    if(Tc[i+1][j]==0 || Tc[i-1][j]==0 || Tc[i][j+1]==0 || Tc[i][j-1]==0)//nb is wall
	      Tc[i][j]=2; //membrane
	  }
      }


  for(i=0;i<n;i++)
    for(j=yzero;j<yEND;j++)
      {
	if(Tc[i][j]==0)//cell wall
	  Tct[i][j]=20;//to get different colour there
      }

  /***********************************************************/

  //still need to subdivide vasc into 9 -10 -11
  int wallcounter2;
  for(j=yzero;j<yEND;j++)
    {
      wallcounter2=0;
      for(i=xm;i>=0;i--)
	{
	  ii=n-1-i;
	  while(Tc[i][j]==0)
	    {
	      i--;
	      ii=n-1-i;
	    }
	  if(Tct[i][j]<9)
	    {
	      i=-(100/xstep);//!//no longer vasculature so end routine
	    }
	  else
	    {
	      while(Tct[i][j]==9)
		{
		  if(wallcounter2==0)//first cell files from middle out
		    {
		      Tct[i][j]=11;
		      Tct[ii][j]=11;
		    }
		  else if(wallcounter2==1)//second cell files from middle out
		    {
		      Tct[i][j]=10;
		      Tct[ii][j]=10;
		    }
		  else if(wallcounter2==2)
		    ;
		  i--;
		  ii=n-1-i;
		}
	      wallcounter2++;
	    }
	}
    }

  /*
  for(i=xm;i>=disttolrc;i--)
    for(j=yzero;j<yEND;j++)
      {
	ii=n-1-i;
	if(Tct[i][j]!=Tct[ii][j])
	  {
	    printf("location %i,%i and %i,%i not identical\n",i,j,ii,j);
	    exit(1);
	  }
      }
  printf("initial cell types fully symmetric\n");  */
}


void Tissue::TNumberCells()
{
  BCell *cell;

  int i,j;
  int q=0;
  //nummer de cellen
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      CellGrid[i][j]=NULL;


  int count=0;
  int nbs;
  int ii,jj;
  int dist;
  for(j=0;j<m;j++)
    for(i=0;i<n;i++)
      {
	if(Tc[i][j]==2 || Tc[i][j]==1)//cell membrane or cytosol
	  {
	    if(j>=yLRC1)

	      {
		if((CellGrid[i-1][j]==NULL && CellGrid[i][j-1]==NULL) &&
		   (CellGrid[i+1][j]==NULL && CellGrid[i][j+1]==NULL))
		  {
		    cell=new BCell();
		    cell->CreateCell(q);
		    (*CellList).push_back(cell);
		    CellGrid[i][j]=cell;
		    q++;
		  }
		else
		  {
		    if(CellGrid[i-1][j]!=NULL)
		      CellGrid[i][j]=CellGrid[i-1][j];
		    else if(CellGrid[i][j-1]!=NULL)
		      CellGrid[i][j]=CellGrid[i][j-1];
		    else if(CellGrid[i+1][j]!=NULL)
		      CellGrid[i][j]=CellGrid[i+1][j];
		    else if(CellGrid[i][j+1]!=NULL)
		      CellGrid[i][j]=CellGrid[i][j+1];
		  }
	      }
	    else
	      {
		nbs=0;
		dist=1;
		for(ii=i-dist;ii<=i+dist;ii++)
		  for(jj=j-dist;jj<=j+dist;jj++)
		    {
		      if(!((ii==i-1 && jj==j-1) || (ii==i+1 && jj==j-1)))
			{
			  if(CellGrid[ii][jj]!=NULL)
			    {
			      CellGrid[i][j]=CellGrid[ii][jj];
			      nbs++;
			      count++;
			      ii=i+1000;
			      jj=j+1000;
			    }
			}
		    }
		jj=j-1;
		ii=i;
		while(ii<i+10 && Tc[ii][j]!=0)
		  {
		    if(CellGrid[ii][jj]!=NULL)
		      {
			CellGrid[i][j]=CellGrid[ii][jj];
			count++;
			nbs++;
			break;
		      }
		    else
		      ii++;
		  }

		if(nbs==0)
		  {
		    cell=new BCell();
		    cell->CreateCell(q);
		    (*CellList).push_back(cell);
		    CellGrid[i][j]=cell;
		    q++;
		    count++;
		  }
	      }
	  }
      }

  actcells=q;
  maxidnr=q-1;//q//numbered from one till q not 1 till and with q.

  printf("nrcells %i maxidnr %i\n",actcells,maxidnr);
}

void Tissue::TFindCellCorners()
{
  int i,j;
  iter it;
  BCell *c;

  if(CellList!=NULL)
    {
      it=CellList->begin();
      while(it!=CellList->end())
	{
	  (*it)->CellMaxI=0;
	  (*it)->CellMinI=10000;
	  (*it)->CellMaxJ=0;
	  (*it)->CellMinJ=10000;
	  (*it)->CellWidth=0;
	  (*it)->CellHeight=0;
#ifndef RESTART
	  (*it)->ContCellHeight=0;//
#endif
	  it++;
	}
    }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
	if(CellGrid[i][j]!=NULL)
	  {
	    c=CellGrid[i][j];
	    if(i>c->CellMaxI)
	      c->CellMaxI=i;
	    if(i<c->CellMinI)
	      c->CellMinI=i;
	    if(j>c->CellMaxJ)
	      c->CellMaxJ=j;
	    if(j<c->CellMinJ)
	      c->CellMinJ=j;
	  }
      }
   if(CellList!=NULL)
    {
      it=CellList->begin();
      while(it!=CellList->end())
	{
	  (*it)->CellWidth=(*it)->CellMaxI-(*it)->CellMinI+1;
	  (*it)->CellHeight=(*it)->CellMaxJ-(*it)->CellMinJ+1;
#ifndef RESTART
	  (*it)->ContCellHeight= (*it)->CellHeight;//
#endif
	  it++;
	}
    }
}

void Tissue::TFindCellSizes()
{
  int i,j;
  iter it;
  BCell *c;
  int cd;

   if(CellList!=NULL)
    {
      it=CellList->begin();
      while(it!=CellList->end())
	{
	  (*it)->CellSize=0;
	  (*it)->InvCellSize=0;
	  it++;
	}
    }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
	if(CellGrid[i][j]!=NULL)
	  {
	    c=CellGrid[i][j];
	    c->CellSize++;
	  }
      }
  if(CellList!=NULL)
    {
      it=CellList->begin();
      while(it!=CellList->end())
	{
	  (*it)->InvCellSize=1.0/((double)(*it)->CellSize);
	  it++;
	}
    }
}


void Tissue::TSetUpMembraneTypes()
{
  int i,ii,j,jj,q,iii,jjj;
  BCell *c;

  //bepaal membrane orientatie: 1: top, 2: bottom, 3: in, 4:out
  //op basis van waar is membraan Tc[i][j]==2, wat voor celltype is het
  //Tct[i][j]=??? en wat is de orientatie van de membraan en dus nearby
  //cell wall Twv[i][j]=???
  for(i=0;i<n;i++)
    for(j=yzero;j<yEND;j++)
      {
	if(Tc[i][j]==2)
	  Tmt[i][j]=10;//dummy orientation if a membrane
	else
	  Tmt[i][j]=0;//no orientation if not a membrane
      }


  //straight part of root + part of rootcap that is more or less straight
  for(i=xm;i>=0;i--)
    for(j=yLRCstraight-1;j<=yEND;j++)//for(j=yR-1;j<=yEND;j++)
      {
	ii=n-1-i;
	if(Tmt[i][j]==10)//there is an unidentified membrane
	  {
	    c=CellGrid[i][j];
	    if(j==c->CellMaxJ)//top
	      {
		Tmt[i][j]=1;
		Tmt[ii][j]=1;
	      }
	    else if(j==c->CellMinJ)//bottom
	      {
		Tmt[i][j]=2;
		Tmt[ii][j]=2;
	      }
	    else if(Tc[i+1][j]==0)//right
	      {
		Tmt[i][j]=3;
		Tmt[ii][j]=3;
	      }
	    else if(Tc[i-1][j]==0)//left
	      {
		Tmt[i][j]=4;
		Tmt[ii][j]=4;
	      }
	  }
      }
  //end of straight part of root + part of rootcap that is more or less straight


  //curved part of root, only vasculature so top and bottom straight
  for(i=xm;i>=0;i--)
    for(j=yQC;j<=yR;j++)
      {
	ii=n-1-i;
	if(Tmt[i][j]==10)//there is an unidentified membrane
	  {
	    c=CellGrid[i][j];
	    if(Tct[i][j]==8 || Tct[i][j]==9 || Tct[i][j]==10 || Tct[i][j]==11)
	      {
		if(j==c->CellMaxJ)//top
		  {
		    Tmt[i][j]=1;
		    Tmt[ii][j]=1;
		  }
		else if(j==c->CellMinJ)//bottom
		  {
		    Tmt[i][j]=2;
		    Tmt[ii][j]=2;
		  }
		else if(Tc[i+1][j]==0)//right
		  {
		    Tmt[i][j]=3;
		    Tmt[ii][j]=3;
		  }
		else if(Tc[i-1][j]==0)//left
		  {
		    Tmt[i][j]=4;
		    Tmt[ii][j]=4;
		  }
	      }
	  }
      }
  //end of curved part of root, only vasculature



  //curved part of root
  //upward and downward oriented membranes relative to radial lines
  for(i=xm;i>=0;i--)
    for(j=yzero;j<=yR;j++)
      {
	ii=n-1-i;
	if(Tmt[i][j]==10)//there is an unidentified membrane
	  {
	    if((j-1)==(int)(arad1*i+brad1) || (i+1)==(int)((j-brad1)/arad1))
	      {
		Tmt[i][j]=2;
		Tmt[ii][j]=2;
	      }
	    else if((j+1)==(int)(arad1*i+brad1)|| (i-1)==(int)((j-brad1)/arad1))
	      {
		Tmt[i][j]=1;
		Tmt[ii][j]=1;
	      }
	    if((j-1)==(int)(arad2*i+brad2)|| (i+1)==(int)((j-brad2)/arad2))
	      {
		Tmt[i][j]=2;
		Tmt[ii][j]=2;
	      }
	    else if((j+1)==(int)(arad2*i+brad2)|| (i-1)==(int)((j-brad2)/arad2)
	      || (j+2)==(int)(arad2*i+brad2)|| (i-1)==(int)((j-brad2)/arad2))
	      {
		//this wall tends to get steep, and therefore the new repair
		//algorithm to ensure continuity of walls kicks in
		//as a consequence distance with the equation for this line
		//is a bit enlarged because the wall has been blown up a bit
		Tmt[i][j]=1;
		Tmt[ii][j]=1;
	      }
	    if((j-1)==(int)(arad3*i+brad3)|| (i+1)==(int)((j-brad3)/arad3))
	      {
		Tmt[i][j]=2;
		Tmt[ii][j]=2;
	      }
	    else if((j+1)==(int)(arad3*i+brad3)|| (i-1)==(int)((j-brad3)/arad3))
	      {
		Tmt[i][j]=1;
		Tmt[ii][j]=1;
	      }
	    if((j-1)==(int)(arad4*i+brad4)|| (i+1)==(int)((j-brad4)/arad4))
	      {
		Tmt[i][j]=2;
		Tmt[ii][j]=2;
	      }
	    else if((j+1)==(int)(arad4*i+brad4)|| (i-1)==(int)((j-brad4)/arad4))
	      {
		Tmt[i][j]=1;
		Tmt[ii][j]=1;
	      }
	    if(i==xm-1)
	      {
		Tmt[i][j]=2;
		Tmt[ii][j]=2;
	      }
	    if(i==xm+1)
	      {
		Tmt[i][j]=2;
		Tmt[ii][j]=2;
	      }
	  }
      }

  //repair missing parts top and down membranes
  int nb_1;
  int nb_2;
  int temp[n][m];
  int th=2;
  for(i=0;i<n;i++)
    for(j=yzero;j<yR;j++)
      temp[i][j]=Tmt[i][j];
  for(i=xm;i>=0;i--)
    for(j=yzero;j<=yR;j++)
      {
	ii=n-1-i;
	if(Tmt[i][j]==10)//type not identified;
	  {
	    nb_1=0;
	    nb_2=0;
	    for(iii=i-1;iii<=i+1;iii++)
	      for(jjj=j-1;jjj<=j+1;jjj++)
		{

		  if(CellGrid[i][j]==CellGrid[iii][jjj] && Tmt[iii][jjj]==1)
		    nb_1++;
		  else if(CellGrid[i][j]==CellGrid[iii][jjj] && Tmt[iii][jjj]==2)
		    nb_2++;
		}
	    if(nb_1>=th)
	      {
		temp[i][j]=1;
		temp[ii][j]=1;
	      }
	    else if(nb_2>=th)
	      {
		temp[i][j]=2;
		temp[ii][j]=2;
	      }
	  }
      }
  for(i=0;i<n;i++)
    for(j=yzero;j<yR;j++)
      Tmt[i][j]=temp[i][j];


  //curved part of root
  //inward and outward oriented membranes relative to parabola
  for(i=xm;i>=0;i--)
    for(j=yzero;j<=yR;j++)
      {
	ii=n-1-i;
	if(Tmt[i][j]==10)//there is an unidentified membrane
	  {
	    //outward pointing membranes
	    if(Tc[i-2][j-2]==3)//outmost cell membrane
	      {
		Tmt[i][j]=4;
		Tmt[ii][j]=4;
	      }
	    else if((i-1)==n-1-(int)(pow(((j-bLRC2)/aLRC2),(1.0/powLRC2))+xm) ||
		    (j-1)==(int)(aLRC2*abs(pow((i-xm),powLRC2))+bLRC2))
	      {
		Tmt[i][j]=4;
		Tmt[ii][j]=4;
	      }
	    else if(j<yLRC3-(1/xstep) &&
			((i-1)==n-1-(int)(pow(((j-bLRC3)/aLRC3),(1.0/powLRC3))+xm) ||
		    (j-1)==(int)(aLRC3*abs(pow((i-xm),powLRC3))+bLRC3))) //!j<yLRC3-1
	      {
		Tmt[i][j]=4;
		Tmt[ii][j]=4;
	      }
	    else if(j<yLRC4-(1/xstep) &&
		    ((i-1)==n-1-(int)(pow(((j-bLRC4)/aLRC4),(1.0/powLRC4))+xm) ||
		     (j-1)==(int)(aLRC4*abs(pow((i-xm),powLRC4))+bLRC4))) //!j<yLRC4-1
	      {
		Tmt[i][j]=4;
		Tmt[ii][j]=4;
	      }
	    else if((i-1)==n-1-(int)(pow(((j-bEPI)/aEPI),(1.0/powEPI))+xm) ||
		    (j-1)==(int)(aEPI*abs(pow((i-xm),powEPI))+bEPI))
	      {
		Tmt[i][j]=4;
		Tmt[ii][j]=4;
	      }
	    else if((i-1)==n-1-(int)(pow(((j-bCORT)/aCORT),(1.0/powCORT))+xm) ||
		    (j-1)==(int)(aCORT*abs(pow((i-xm),powCORT))+bCORT))
	      {
		Tmt[i][j]=4;
		Tmt[ii][j]=4;
	      }
	    else if((i-1)==n-1-(int)(pow(((j-bENDO)/aENDO),(1.0/powENDO))+xm) ||
		    (j-1)==(int)(aENDO*abs(pow((i-xm),powENDO))+bENDO))
	      {
		if(j>(int)(arad4*i+brad4))
		  {
		    Tmt[i][j]=4;
		    Tmt[ii][j]=4;
		  }
	      }
	    else if((i-1)==n-1-(int)(pow(((j-bPERI)/aPERI),(1.0/powPERI))+xm) ||
		    (j-1)==(int)(aPERI*abs(pow((i-xm),powPERI))+bPERI))
	      {
		Tmt[i][j]=4;
		Tmt[ii][j]=4;
	      }
	    else if((i-1)==n-1-(int)(pow(((j-bVASC)/aVASC),(1.0/powVASC))+xm) ||
		    (j-1)==(int)(aVASC*abs(pow((i-xm),powVASC))+bVASC))
	      {
		Tmt[i][j]=4;
		Tmt[ii][j]=4;
	      }


	    //inward pointing membranes
	    if((i+1)==n-1-(int)(pow(((j-bLRC2)/aLRC2),(1.0/powLRC2))+xm) ||
	       (j+1)==(int)(aLRC2*abs(pow((i-xm),powLRC2))+bLRC2))
	      {
		Tmt[i][j]=3;
		Tmt[ii][j]=3;
	      }
	    else if((i+1)==n-1-(int)(pow(((j-bLRC3)/aLRC3),(1.0/powLRC3))+xm) ||
	       (j+1)==(int)(aLRC3*abs(pow((i-xm),powLRC3))+bLRC3))
	      {
		Tmt[i][j]=3;
		Tmt[ii][j]=3;
	      }
	    else if(j<yLRC4-(1/xstep) &&
		    ((i+1)==n-1-(int)(pow(((j-bLRC4)/aLRC4),(1.0/powLRC4))+xm) ||
		     (j+1)==(int)(aLRC4*abs(pow((i-xm),powLRC4))+bLRC4))) //!j<yLRC4-1
	      {
		Tmt[i][j]=3;
		Tmt[ii][j]=3;
	      }
	    else if((i+1)==n-1-(int)(pow(((j-bEPI)/aEPI),(1.0/powEPI))+xm) ||
	       (j+1)==(int)(aEPI*abs(pow((i-xm),powEPI))+bEPI))
	      {
		Tmt[i][j]=3;
		Tmt[ii][j]=3;
	      }
	    else if((i+1)==n-1-(int)(pow(((j-bCORT)/aCORT),(1.0/powCORT))+xm) ||
	       (j+1)==(int)(aCORT*abs(pow((i-xm),powCORT))+bCORT))
	      {
		Tmt[i][j]=3;
		Tmt[ii][j]=3;
	      }
	    else if((i+1)==n-1-(int)(pow(((j-bENDO)/aENDO),(1.0/powENDO))+xm) ||
	       (j+1)==(int)(aENDO*abs(pow((i-xm),powENDO))+bENDO))
	      {
		if(j>(int)(arad4*i+brad4))
		  {
		    Tmt[i][j]=3;
		    Tmt[ii][j]=3;
		  }
	      }
	    else if((i+1)==n-1-(int)(pow(((j-bPERI)/aPERI),(1.0/powPERI))+xm) ||
	       (j+1)==(int)(aPERI*abs(pow((i-xm),powPERI))+bPERI))
	      {
		Tmt[i][j]=3;
		Tmt[ii][j]=3;
	      }
	    else if((i+1)==n-1-(int)(pow(((j-bVASC)/aVASC),(1.0/powVASC))+xm) ||
	       (j+1)==(int)(aVASC*abs(pow((i-xm),powVASC))+bVASC))
	      {
		Tmt[i][j]=3;
		Tmt[ii][j]=3;
	      }
	  }
      }
  //repair missing parts in en outward membranes
  int nb_3;
  int nb_4;
  int iter=4;
  for(int k=0;k<iter;k++)
    {
  for(i=0;i<n;i++)
    for(j=yzero;j<yR;j++)
      temp[i][j]=Tmt[i][j];
  for(i=xm;i>=0;i--)
    for(j=yzero;j<=yR;j++)
      {
	ii=n-1-i;
	if(Tmt[i][j]==10)//type not identified;
	  {
	    nb_3=0;
	    nb_4=0;
	    for(iii=i-1;iii<=i+1;iii++)
	      for(jjj=j-1;jjj<=j+1;jjj++)
		{
		  if(CellGrid[i][j]==CellGrid[iii][jjj] && Tmt[iii][jjj]==3)
		    nb_3++;
		  else if(CellGrid[i][j]==CellGrid[iii][jjj] && Tmt[iii][jjj]==4)
		    nb_4++;
		}
	    if(nb_3>=1)
	      {
		temp[i][j]=3;
		temp[ii][j]=3;
	      }
	    else if(nb_4>=1)
	      {
		temp[i][j]=4;
		temp[ii][j]=4;
	      }
	  }
      }
   for(i=0;i<n;i++)
    for(j=yzero;j<yR;j++)
      Tmt[i][j]=temp[i][j];
    }

  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
	if(Tc[i][j]==0)//cell wall
	  Tct[i][j]=20;//to get different colour there
      }


  //check symmetry initial tissue layout
  for(j=0;j<m;j++)
    for(i=0;i<xm;i++)
      {
	ii=n-1-i;
	if(Tmt[i][j]!=Tmt[ii][j])//if(Tc[i][j]!=Tc[ii][j])
	  {
	    printf("something is wrong in tissue layout at %i %i and %i %i celltype is %i and %i\n",i,j,n-1-i,j,Tct[i][j],Tct[n-1-i][j]);
	  }
      }

  //printf("finished checking initial tissue layout\n");
  //exit(1);


}

void Tissue::TInitConditions()
{
  int i,j;
  iter it;

   if(CellList!=NULL)
    {
      it=CellList->begin();
      while(it!=CellList->end())
	{
	  (*it)->InitCell();
	  it++;
	}
    }

   //set auxin concentration levels:
   for(i=0;i<n;i++)
     for(j=0;j<m;j++)
       {
	 if(Tc[i][j]!=3 && CellGrid[i][j]!=NULL)
	   {
	     if(j<10)
	       Caux1[i][j]=3500;
	     else if(j<30)
	       Caux1[i][j]=1700;
	     else if(j<60)
	       Caux1[i][j]=900;
	     else if(j<100)
	       Caux1[i][j]=400;
	     else if(j<250)
	       Caux1[i][j]=60;
	     else if(j<500)
	       Caux1[i][j]=20;
	     else
	       Caux1[i][j]=0.5;
	  }
      }
}

void Tissue::GenerateTissue()
{
  CellList=new list<BCell*>();

  SetUpTissueLayout();
  TNumberCells();
  TFindCellCorners();
  TFindCellSizes();
  TSetUpMembraneTypes();
  TInitConditions();
  UpdateFluxesTissue(0);
}


void Tissue::GeneratePlantFromFile(int t)
{
  FILE *f;
  int i,j,q;
  char fname2[800];
  float temp;
  int temp2;
  iter it;

  printf("starting reading in from file\n");

  sprintf(fname2,"%s/DumpPlantStateAt%.10d",dirname,t);
  f=fopen(fname2,"r");

  printf("opened file\n");

  //tissue architecture and cell numbering
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      fscanf(f,"%i ",&(Tc[i][j]));
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      fscanf(f,"%i ",&(Tct[i][j]));
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      fscanf(f,"%i ",&(Tmt[i][j]));

  printf("scanned in tissue architecture\n");

  //location of transporters
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
	fscanf(f,"%g ",&temp);
	PinPrePat[i][j]=temp;
      }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
	fscanf(f,"%g ",&temp);
	Aux1PrePat[i][j]=temp;
      }
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
	fscanf(f,"%g ",&temp);
	Lax3PrePat[i][j]=temp;
      }
  //auxin levels on grid
  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
	fscanf(f,"%g ",&temp);
	Caux1[i][j]=temp;
      }

  printf("read in grid properties\n");

  //nr of cells
  fscanf(f,"%i",&actcells);

  CellList=new list<BCell*>();
  BCell *cell;
  maxidnr=-1;

  for(i=0;i<actcells;i++)
    {
      //NEED TO ADD: Rdiv, Relong, Rgrow, Rgrowavg, memARF

      cell=new BCell();
      fscanf(f,"%i ",&temp2);
      cell->CreateCell(temp2);
      if(temp2>maxidnr)
	maxidnr=temp2;

      fscanf(f,"%g ",&temp);
      cell->MeanCells=temp;
      fscanf(f,"%g ",&temp);
      cell->AuxinSign=temp;
      fscanf(f,"%g ",&temp);
      cell->CumAuxin=temp;
      fscanf(f,"%g ",&temp);
      cell->ARF=temp;
      fscanf(f,"%g ",&temp);
      cell->AA=temp;
      fscanf(f,"%g ",&temp);
      cell->BB=temp;
      fscanf(f,"%g ",&temp);
      cell->CC=temp;
      fscanf(f,"%g ",&temp);
      cell->DD=temp;
      fscanf(f,"%g ",&temp);
      cell->Plt=temp;
      fscanf(f,"%g ",&temp);
      cell->Yuc3=temp;
      fscanf(f,"%g ",&temp);
      cell->Lec2Fus3=temp;
      fscanf(f,"%g ",&temp);
      cell->Pin=temp;
      fscanf(f,"%g ",&temp);
      cell->Plts=temp;
      fscanf(f,"%g ",&temp);
      cell->Aux1=temp;
      fscanf(f,"%g ",&temp);
      cell->Lax3=temp;
      fscanf(f,"%i ",&temp2);
      cell->TimePrevGrowth=temp2;
      fscanf(f,"%g ",&temp);
      cell->Diff=temp;
      fscanf(f,"%g ",&temp);
      cell->PP=temp;
      fscanf(f,"%i ",&temp2);
      cell->CellZonationState=temp2;
      fscanf(f,"%g ",&temp);
      cell->Rdiv=temp;
      fscanf(f,"%g ",&temp);
      cell->Relong=temp;
      fscanf(f,"%g ",&temp);
      cell->Rgrow=temp;
      fscanf(f,"%g ",&temp);
      cell->Rgrowavg=temp;
      fscanf(f,"%g ",&temp);
      cell->memARF=temp;
      fscanf(f,"%g ",&temp);
      cell->memARFtot=temp;
      fscanf(f,"%g ",&temp);
      cell->Ra=temp;
      fscanf(f,"%g ",&temp);
      cell->epiO=temp;
      fscanf(f,"%g ",&temp);
      cell->ContCellHeight=temp;
      //printf("cell height is %f\n",cell->ContCellHeight);
      fscanf(f,"%g ",&temp);
      cell->IAAreg=temp;
      //fscanf(f,"%g ",&temp);
      //cell->TOLS2=temp;
      //cell->TOLS2=0;

      cell->AHP6=0;
      cell->CKlevel=0;
      cell->CKmean=0;
      cell->CKsignal=0;
      cell->polarisation=0;
      cell->pinup=0;
      cell->pindown=1;
      cell->pinin=0.1;


      (*CellList).push_back(cell);
    }

  for(i=0;i<n;i++)
    for(j=0;j<m;j++)
      {
	fscanf(f,"%i ",&temp2);
	if(temp2!=-1)//there is a cell there
	  {
	    //now you know id of cell
	    //find this cell in CellList
	    //put pointer to it in CellGrid

	    if(!(CellList==NULL))
	      {
		it=CellList->begin();
		while(it!=CellList->end())
		  {
		    if((*it)->cellid==temp2)
		      {
			CellGrid[i][j]=(*it);
			it=CellList->end();//to achieve break
		      }
		    else
		      it++;
		  }
	      }
	  }
	else
	  CellGrid[i][j]=NULL;
      }


  fclose(f);

  TFindCellCorners();
  TFindCellSizes();
  UpdateFluxesTissue(0);

}

void Tissue::WritePlantToFile(int t)
{
  FILE *f;
  int i,j,q;
  char fname[800];
  sprintf(fname,"%s/DumpPlantStateAt%.10d",dirname,t);
  f=fopen(fname,"w");


  //tissue architecture and cell numbering
  for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	fprintf(f,"%i\t",Tc[i][j]);
      fprintf(f,"\n");
    }
  for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	fprintf(f,"%i\t",Tct[i][j]);
      fprintf(f,"\n");
    }
  for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	fprintf(f,"%i\t",Tmt[i][j]);
      fprintf(f,"\n");
    }

  //location of transporters
  for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	fprintf(f,"%.17g\t",PinPrePat[i][j]);
      fprintf(f,"\n");
    }
  for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	fprintf(f,"%.17g\t",Aux1PrePat[i][j]);
      fprintf(f,"\n");
    }
	for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	fprintf(f,"%.17g\t",Lax3PrePat[i][j]);
      fprintf(f,"\n");
    }

  //auxin levels on the grid
  for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	fprintf(f,"%.17g\t",Caux1[i][j]);
      fprintf(f,"\n");
    }

  //nr of cells
  fprintf(f,"%i\n",actcells);

  iter it;
  if(CellList!=NULL)
    {
      it=CellList->begin();
      while(it!=CellList->end())
	{
	  //NEED TO ADD: Rdiv, Relong, Rgrow, Rgrowavg, memARF
	  fprintf(f,"%i\t",(*it)->cellid);
	  fprintf(f,"%.17g\t",(*it)->MeanCells);
	  fprintf(f,"%.17g\t",(*it)->AuxinSign);
	  fprintf(f,"%.17g\t",(*it)->CumAuxin);
	  fprintf(f,"%.17g\t",(*it)->ARF);
	  fprintf(f,"%.17g\t",(*it)->AA);
	  fprintf(f,"%.17g\t",(*it)->BB);
	  fprintf(f,"%.17g\t",(*it)->CC);
	  fprintf(f,"%.17g\t",(*it)->DD);
	  fprintf(f,"%.17g\t",(*it)->Plt);
	  fprintf(f,"%.17g\t",(*it)->Yuc3);
	  fprintf(f,"%.17g\t",(*it)->Lec2Fus3);
	  fprintf(f,"%.17g\t",(*it)->Pin);
	  fprintf(f,"%.17g\t",(*it)->Plts);
	  fprintf(f,"%.17g\t",(*it)->Aux1);
	  fprintf(f,"%.17g\t",(*it)->Lax3);
	  fprintf(f,"%i\t",(*it)->TimePrevGrowth);
	  fprintf(f,"%.17g\t",(*it)->Diff);
	  fprintf(f,"%.17g\t",(*it)->PP);
	  fprintf(f,"%i\t",(*it)->CellZonationState);
	  fprintf(f,"%.17g\t",(*it)->Rdiv);
	  fprintf(f,"%.17g\t",(*it)->Relong);
	  fprintf(f,"%.17g\t",(*it)->Rgrow);
	  fprintf(f,"%.17g\t",(*it)->Rgrowavg);
	  fprintf(f,"%.17g\t",(*it)->memARF);
	  fprintf(f,"%.17g\t",(*it)->memARFtot);
	  fprintf(f,"%.17g\t",(*it)->Ra);
	  fprintf(f,"%.17g\t",(*it)->epiO);
	  fprintf(f,"%.17g\t",(*it)->ContCellHeight);
	  fprintf(f,"%.17g\t",(*it)->IAAreg);
	  fprintf(f,"%.17g\t",(*it)->TOLS2);
	  fprintf(f,"\n");
	  it++;
	}
    }

  //not sensible to store pointers to cells in file
  //instead store ids
  //upon reading in ids can be used to find matching
  //cell in CellList, and then use pointer to this Cell
  //to fill CellGrid array
  for(i=0;i<n;i++)
    {
      for(j=0;j<m;j++)
	{
	  if(CellGrid[i][j]!=NULL)
	    fprintf(f,"%i\t",CellGrid[i][j]->cellid);
	  else
	    fprintf(f,"%i\t",-1);
	}
      fprintf(f,"\n");
    }

  fclose(f);
}
