#include "Header.hh"
#include "dSFMT.h"
#include "Tissue.hh"
#include "BCell.hh"

/*
void StoreAndCompare(int time, int starttime)
{	
  int q,i,j;
  static int totcells_init=0;
  int first_time[totcells];
 
  for(q=totcells_init;q<totcells;q++)
       first_time[q]=0;
    
    

for(q=0;q<totcells;q++)
{
	 if(first_time[q]==0)
	   {
		  BaselineAuxine[q]=MeanCells[q];
		  DiffAuxine[q]=0;
		  TimeOfAuxineIncrease[q]=-100;
		  first_time[q]=1;
		  totcells_init = totcells;
	   }
	 else
		DiffAuxine[q]=(MeanCells[q]-BaselineAuxine[q]);

		   
		  if(TimeOfAuxineIncrease[q]<0)//has not increased before
			{
			  if(DiffAuxine[q]>0.1*BaselineAuxine[q]) // MeanCells[q])//>0.001)
				TimeOfAuxineIncrease[q]=((double)(time-starttime));
			}
		
 }    
   MakePNGFile(time,0);

   

}

void AuxinIncrease(int time)   //, int starttime)
{
  static int totcells_init=0;
  int first_time[totcells];
  int q,i,j;

 for(q=totcells_init;q<totcells;q++)
       first_time[q]=0;
  
      
       for(q=0;q<totcells;q++)
       {
			if(first_time[q]==0)
			{
			  BaseMeanCell[q]=MeanCells[q];		
			  TempAuxin[q]=0;
			  first_time[q]=1;
			  
			}	
		
		    else
			{
			  TempAuxin[q]=(MeanCells[q]-BaseMeanCell[q]);
			}
			totcells_init = totcells;
		}
       
     
    // for(i=0;i<n;i++)
       //for(j=0;j<m;j++)
       for(q=0;q<totcells;q++)
       {
	  if(TempAuxin[q]!=0)//has not increased before
	    {
			
	        IncrAuxin[q] = TempAuxin[q]/BaseMeanCell[q];
	        TempAuxin[q]=0;
	       
	    }
	  else
			IncrAuxin[q] = TempAuxin[q];
		}
		
    
     MakePNGFile(time,6);

     
 }
*/



void Tissue::VisualiseFluxGridBased(int time)
{
  int i,j,q;
  double flux_x,flux_y;
  double minfluxsize=100000;
  double maxfluxsize=0;
  double minangle=100;
  double maxangle=0;
   
  FILE *PNGFileP;
  png_structp png_ptr;
  png_infop info_ptr;
  png_bytep row_pointer;
  char fname[500];
  const int WW=zoom*m;
  const int LL=zoom*n;
  unsigned char RGBdata[LL*WW*3];
   
  double size,angle,dummy,alpha,beta,gamma;
   
  //printf("m is %i\n",m);
  
  for(i=0;i<LL;i++)
    for(j=0;j<WW;j++)
      {
	int ii=i/zoom;
	int jj=j/zoom;
	
	if(Tc[ii][jj]!=3)//walls, membranes cytoplasm???? 
	  {
	    //only diffusion?????
	    flux_x=DiffAuxC[ii][jj][0]*(Caux1[ii][jj]-Caux1[ii+1][jj])+DiffAuxC[ii][jj][1]*(Caux1[ii-1][jj]-Caux1[ii][jj]);
	    flux_y=DiffAuxC[ii][jj][2]*(Caux1[ii][jj]-Caux1[ii][jj+1])+DiffAuxC[ii][jj][3]*(Caux1[ii][jj-1]-Caux1[ii][jj]);

	    //more sense to do diffusion only for cytoplasm points
	    //and to do inf/eff for membrane points 
	    //and ignore wall points?


	    size=sqrt(flux_x*flux_x+flux_y*flux_y)+0.01;
	    if(size>maxfluxsize)
	      maxfluxsize=size;
	    if(size<minfluxsize)
	      minfluxsize=size;

	    //ga voor inward + outward - ipv right + left - 	
	    if(i<n/2)//left cell
	      ;
	    else//right cell
	      flux_x=-flux_x;
	    //if(flux[i][j][0]<0.5*flux[i][j][1])
	    flux_x=4*flux_x;
	    
	    angle=atan2(flux_y,flux_x);
	    if(angle>maxangle)
	      maxangle=angle;
	    if(angle<minangle)
	      minangle=angle;


	    size=log10(size);
	    if(size<-2)
	      {
		size=-2;
		printf("warning flux size smaller than 10^-2\n");
	      }
	    else if(size>5)
	      {
		size=5;
		printf("warning flux size larger than 10^5\n");
	      }
	    size=size+2;//from 0 till 7
	    size=(int)(50.*size);//50*log10(fluxsize[q]);//250;
	    

	    if(angle<-M_PI)
	       {
		 printf("warning flux angle smaller than -pi\n");
		 angle=-M_PI;
	       }
	     else if(angle>M_PI)
	       {
		 printf("warning flux angle larger than pi\n");
		 angle=M_PI;
	       }
	     angle=angle+M_PI;//from 0 till 2*pi
	     
	     
	     //for testing
	     //size=254;
	     //angle=(jj/147.0);

	     
	     if(angle<(2./3.)*M_PI)
	       {
		 gamma=0;//no blue
		 dummy=angle/((2./3.)*M_PI);
		 if(dummy<=0.5)
		   {
		     alpha=1;
		     beta=2*dummy;
		   }
		 else
		   {
		     alpha=1-2*(dummy-0.5);//1-dummy;
		     beta=1;
		   }
	       }
	     else if(angle<(4./3.)*M_PI)
	       {
		 alpha=0;//no red
		 dummy=(angle-(2./3.)*M_PI)/((2./3.)*M_PI);
		 if(dummy<=0.5)
		   {
		     beta=1;
		     gamma=2*dummy;
		   }
		 else
		   {
		     gamma=1;
		     beta=1-2*(dummy-0.5);//1-dummy;
		   }
	       }
	     else
	       {
		 beta=0;//no green
		 dummy=(angle-(4./3.)*M_PI)/((2./3.)*M_PI);
		 if(dummy<=0.5)
		   {
		     gamma=1;
		     alpha=2*dummy;
		   }
		 else
		   {
		     alpha=1;
		     gamma=1-2*(dummy-0.5);//1-dummy;
		   }
	       }
	     
	     /*alpha=1;
	       beta=0;
	       gamma=0;*/
	     
	     RGBdata[j*LL*3+i*3+0]=size*alpha;
	     RGBdata[j*LL*3+i*3+1]=size*beta;
	     RGBdata[j*LL*3+i*3+2]=size*gamma;
	   }
	 else 
	   {
	     RGBdata[j*LL*3+i*3+0]=254;
	     RGBdata[j*LL*3+i*3+1]=254;
	     RGBdata[j*LL*3+i*3+2]=254;
	   }
   }
   
  //printf("minfluxsize %f %f maxfluxsize %f %f\n",minfluxsize,log10(minfluxsize+0.0001),maxfluxsize,log10(maxfluxsize));
  //printf("minangle %f %f maxangle %f %f\n",minangle,minangle*180/M_PI,maxangle,maxangle*180/M_PI);
 

   sprintf(fname,"%s/FluxGrid_%.8d.png",dirname,time);
   PNGFileP = fopen(fname, "wb");
   png_ptr = png_create_write_struct(PNG_LIBPNG_VER_STRING,(png_voidp) NULL,
				     (png_error_ptr) NULL,
				     (png_error_ptr) NULL );
   if(!png_ptr){
     printf("out of memory\n");
     exit(1);
   }
   info_ptr = png_create_info_struct ( png_ptr );
   if(!info_ptr){
     png_destroy_write_struct(&png_ptr, NULL);
     printf("out of memory\n");
     exit(1);
   }
   png_init_io ( png_ptr, PNGFileP );
   png_set_IHDR(png_ptr, info_ptr,LL,WW,
		8, PNG_COLOR_TYPE_RGB, PNG_INTERLACE_NONE,
		PNG_COMPRESSION_TYPE_DEFAULT, PNG_FILTER_TYPE_DEFAULT);
   png_write_info ( png_ptr, info_ptr );
   /*write out image, one row at a time*/
   int row;
   for(row = WW-1; row >= 0; row--){
     row_pointer = ( RGBdata + LL * row * 3 );
     png_write_rows ( png_ptr, &row_pointer, 1 );
   }
   png_write_end ( png_ptr, info_ptr );
   fflush ( PNGFileP );
   png_destroy_write_struct ( &png_ptr,&info_ptr);
   fclose(PNGFileP);    
}



void Tissue::VisualiseFluxCellBased(int time)
{
  int i,j,q;
  iter it;
  BCell *c;
  double flux[totcells][2];
  double fluxangle[totcells];
  double fluxsize[totcells];
  double dummypict[n][m];

  for(i=0;i<totcells;i++)
    {
      flux[i][0]=0;
      flux[i][1]=0;
      fluxangle[i]=0;
      fluxsize[i]=0;
    }
  //in arrays X[n][m][4]:
  //0 is right, 1 is left, 2 is up, 3 is down
  int v0[2]={-1,0};//perpendicular to right membrane,inward pointing
  int v1[2]={1,0};//perpendicular to left membrane, inward pointing
  int v2[2]={0,-1};//perpendicular to top membrane, inward pointing
  int v3[2]={0,1};//perpendicular to bottom membrane, inward pointing


  if(CellList!=NULL)
    {
      it=CellList->begin();
      q=0;
      while(it!=CellList->end())
	{
	  c=(*it);
	  for(i=c->CellMinI;i<=c->CellMaxI;i++)
	    for(j=c->CellMinJ;j<=c->CellMaxJ;j++)
	      {
		
		flux[q][0]+=((Eff[i][j][0])*v0[0]+
			     (Eff[i][j][1])*v1[0]+
			     (Eff[i][j][2])*v2[0]+
			     (Eff[i][j][3])*v3[0])*Caux1[i][j]/((double)xstep);
		flux[q][0]+=(Inf[i][j][0]*v0[0]*Caux1[i+1][j]+
			     Inf[i][j][1]*v1[0]*Caux1[i-1][j]+
			     Inf[i][j][2]*v2[0]*Caux1[i][j+1]+
			     Inf[i][j][3]*v3[0]*Caux1[i][j-1])/((double)xstep);
		flux[q][1]+=((Eff[i][j][0])*v0[1]+
			     (Eff[i][j][1])*v1[1]+
			     (Eff[i][j][2])*v2[1]+
			     (Eff[i][j][3])*v3[1])*Caux1[i][j]/((double)xstep);
		flux[q][1]+=(Inf[i][j][0]*v0[1]*Caux1[i+1][j]+
			     Inf[i][j][1]*v1[1]*Caux1[i-1][j]+
			     Inf[i][j][2]*v2[1]*Caux1[i][j+1]+
			     Inf[i][j][3]*v3[1]*Caux1[i][j-1])/((double)xstep);
	      }
	  it++;
	  q++;
	}
     }
   double minfluxsize=100000;
   double maxfluxsize=0;
   double minangle=100;
   double maxangle=0;
   if(CellList!=NULL)
    {
      it=CellList->begin();
      q=0;
      while(it!=CellList->end())
	{
	  c=(*it);
	  {
	    fluxsize[q]=sqrt(flux[q][0]*flux[q][0]+flux[q][1]*flux[q][1])+0.01;
	    if(fluxsize[q]>maxfluxsize)
	      maxfluxsize=fluxsize[q];
	    if(fluxsize[q]<minfluxsize)
	      minfluxsize=fluxsize[q];
	    
	    //ga voor inward + outward - ipv right + left -
	    if(c->CellMaxI<n/2)//left cell
	      ;
	    else//right cell
	      flux[q][0]=-flux[q][0];
	    
	    //flux[q][0]=30*flux[q][0];
	    //flux[q][1]=0.001*flux[q][1];
	    
	    fluxangle[q]=atan2(flux[q][1],flux[q][0]);
	    if(fluxangle[q]>maxangle)
	      maxangle=fluxangle[q];
	    if(fluxangle[q]<minangle)
	      minangle=fluxangle[q];
	  }
	  it++;
	  q++;
	}
    }
   printf("minfluxsize %f %f maxfluxsize %f %f\n",minfluxsize,log10(minfluxsize),maxfluxsize,log10(maxfluxsize));
   printf("minangle %f %f maxangle %f %f\n",minangle,minangle*180/M_PI,maxangle,maxangle*180/M_PI);
   
   
   /*
   for(i=0;i<n;i++)
     for(j=0;j<m;j++)
       dummypict[i][j]=0;
   for(i=0;i<n;i++)
     for(j=0;j<m;j++)
       {
	 if(Cell[i][j]!=-1)
	   {
	     q=Cell[i][j];
	     if(abs(flux[q][1])>abs(flux[q][0]))//mostly vertical
	       {
		 if(flux[q][1]>0)//upward
		   dummypict[i][j]=1;
		 else//downward
		   dummypict[i][j]=2;
	       }
	     else//mostly horizontal
	       {
		 if(flux[q][0]>0)//rightward
		   dummypict[i][j]=3; 
		 else//leftward
		   dummypict[i][j]=4;
	       }
	     //dummypict[i][j]=log10(fluxsize[q]);
	     dummypict[i][j]=fluxangle[q];
	   }
       }
   MakePNGFile(dirname,dummypict,time,0);
   */
   
   FILE *PNGFileP;
   png_structp png_ptr;
   png_infop info_ptr;
   png_bytep row_pointer;
   char fname[500];
   const int WW=zoom*m;
   const int LL=zoom*n;
   unsigned char RGBdata[LL*WW*3];
   
   double size,angle,dummy,alpha,beta,gamma;

    
   for(i=0;i<LL;i++)
     for(j=0;j<WW;j++)
       {
	 RGBdata[j*LL*3+i*3+0]=0;
	 RGBdata[j*LL*3+i*3+1]=0;
	 RGBdata[j*LL*3+i*3+2]=0;
       }
   
   if(CellList!=NULL)
    {
      it=CellList->begin();
      q=0;
      while(it!=CellList->end())
	{
	  c=(*it);
	  {
	    
	    size=log10(fluxsize[q]);
	    if(size<-2)//if(size<-1)//if(size<-2)
	      {
		size=-2;//size=-1;//size=-2;
		//printf("warning flux size smaller than 10^-2\n");
	      }
	    else if(size>3)//else if(size>5)
	      {
		size=3;//size=5;
		//printf("warning flux size larger than 10^5\n");
	      }
	    size=size+2;//size+1;//size=size+2;//from 0 till 7
	    size=(int)(36.2*size);//(int)(63*size);//size=(int)(36.2*size);//50*log10(fluxsize[q]);//250;
	    /*
	    size=fluxsize[q];
	    if(size>250)
	      size=250;
	    */
	    angle=fluxangle[q];
	    if(angle<-M_PI)
	      {
		//printf("warning flux angle smaller than -pi\n");
		angle=-M_PI;
	      }
	    else if(angle>M_PI)
	      {
		//printf("warning flux angle larger than pi\n");
		angle=M_PI;
	      }
	    angle=angle+M_PI;//from 0 till 2*pi
	    
	    if(angle<(2./3.)*M_PI)
	      {
		gamma=0;//no blue
		dummy=angle/((2./3.)*M_PI);
		if(dummy<=0.5)
		  {
		    alpha=1;
		    beta=2*dummy;
		  }
		else
		  {
		    alpha=1-2*(dummy-0.5);//1-dummy;
		    beta=1;
		  }
	      }
	    else if(angle<(4./3.)*M_PI)
	      {
		alpha=0;//no red
		dummy=(angle-(2./3.)*M_PI)/((2./3.)*M_PI);
		if(dummy<=0.5)
		  {
		    beta=1;
		    gamma=2*dummy;
		  }
		else
		  {
		    gamma=1;
		    beta=1-2*(dummy-0.5);//1-dummy;
		  }
	      }
	    else
	      {
		beta=0;//no green
		dummy=(angle-(4./3.)*M_PI)/((2./3.)*M_PI);
		if(dummy<=0.5)
		  {
		    gamma=1;
		    alpha=2*dummy;
		  }
		else
		  {
		    alpha=1;
		    gamma=1-2*(dummy-0.5);//1-dummy;
		  }
	      }
	    if(c->CellMaxJ>yLRCstraight)
	      {
		for(i=zoom*c->CellMinI;i<=zoom*c->CellMaxI;i++)
		  for(j=zoom*c->CellMinJ;j<=zoom*c->CellMaxJ;j++)
		    {
		      RGBdata[j*LL*3+i*3+0]=size*alpha;
		      RGBdata[j*LL*3+i*3+1]=size*beta;
		      RGBdata[j*LL*3+i*3+2]=size*gamma;
		    }
	      }
	    else
	      {  
		for(i=zoom*c->CellMinI;i<=zoom*c->CellMaxI;i++)
		  for(j=zoom*c->CellMinJ;j<=zoom*c->CellMaxJ;j++)
		    {
		      int ii=i/zoom;
		      int jj=j/zoom;
		      BCell *c2;
		      c2=CellGrid[ii][jj];
		      if(c2!=NULL)
			{
			  if(c2->cellid==c->cellid)
			    {
			      RGBdata[j*LL*3+i*3+0]=size*alpha;
			      RGBdata[j*LL*3+i*3+1]=size*beta;
			      RGBdata[j*LL*3+i*3+2]=size*gamma;
			    }
			}
		    }
	      }
	  }
	  it++;
	  q++;
	}
    }

   sprintf(fname,"%s/FluxCell_%.8d.png",dirname,time);
   PNGFileP = fopen(fname, "wb");
   png_ptr = png_create_write_struct(PNG_LIBPNG_VER_STRING,(png_voidp) NULL,
				     (png_error_ptr) NULL,
				     (png_error_ptr) NULL );
   if(!png_ptr){
     printf("out of memory\n");
     exit(1);
   }
   info_ptr = png_create_info_struct ( png_ptr );
   if(!info_ptr){
     png_destroy_write_struct(&png_ptr, NULL);
     printf("out of memory\n");
     exit(1);
   }
   png_init_io ( png_ptr, PNGFileP );
   png_set_IHDR(png_ptr, info_ptr,LL,WW,
		8, PNG_COLOR_TYPE_RGB, PNG_INTERLACE_NONE,
		PNG_COMPRESSION_TYPE_DEFAULT, PNG_FILTER_TYPE_DEFAULT);
   png_write_info ( png_ptr, info_ptr );
   /*write out image, one row at a time*/
   int row;
   for(row = WW-1; row >= 0; row--){
     row_pointer = ( RGBdata + LL * row * 3 );
     png_write_rows ( png_ptr, &row_pointer, 1 );
   }
   png_write_end ( png_ptr, info_ptr );
   fflush ( PNGFileP );
   png_destroy_write_struct ( &png_ptr,&info_ptr);
   fclose(PNGFileP);
   
   
   char s[1000];
   sprintf(s,"convert %s/SatAuxSign_%.8d.png  %s/FluxCell_%.8d.png +append %s/Fluxes_%.8d.png",dirname,time,dirname,time,dirname,time);
  system(s);

  sprintf(s,"convert %s/Fluxes_%.8d.png  %s/CellZonation_%.8d.png +append %s/Fluxes_%.8d.png",dirname,time,dirname,time,dirname,time);
  system(s);
   

}


void Tissue::MakeColorBar()
{

   FILE *PNGFileP;
   png_structp png_ptr;
   png_infop info_ptr;
   png_bytep row_pointer;
   char fname[500];
   const int WW=zoom*1000;
   const int LL=zoom*100;
   unsigned char RGBdata[LL*WW*3];
   int i,j;
   
   double size,angle,dummy,alpha,beta,gamma;

   size=100;
   for(i=0;i<LL;i++)
     for(j=0;j<WW;j++)
       {
	 //j to angle to color
	 angle=-M_PI+((double)j/(double)WW)*2*M_PI;
	 if(angle<-M_PI)
	    {
	      printf("warning flux angle smaller than -pi\n");
	      angle=-M_PI;
	    }
	  else if(angle>M_PI)
	    {
	      printf("warning flux angle larger than pi\n");
	      angle=M_PI;
	    }
	  angle=angle+M_PI;//from 0 till 2*pi
	    
	  if(angle<(2./3.)*M_PI)
	    {
	      gamma=0;//no blue
	      dummy=angle/((2./3.)*M_PI);
	      if(dummy<=0.5)
		{
		  alpha=1;
		  beta=2*dummy;
		}
	      else
		{
		  alpha=1-2*(dummy-0.5);//1-dummy;
		  beta=1;
		}
	    }
	  else if(angle<(4./3.)*M_PI)
	    {
	      alpha=0;//no red
	      dummy=(angle-(2./3.)*M_PI)/((2./3.)*M_PI);
	      if(dummy<=0.5)
		{
		  beta=1;
		  gamma=2*dummy;
		}
	      else
		{
		  gamma=1;
		  beta=1-2*(dummy-0.5);//1-dummy;
		}
	    }
	  else
	    {
	      beta=0;//no green
	      dummy=(angle-(4./3.)*M_PI)/((2./3.)*M_PI);
	      if(dummy<=0.5)
		{
		  gamma=1;
		  alpha=2*dummy;
		}
	      else
		{
		  alpha=1;
		  gamma=1-2*(dummy-0.5);//1-dummy;
		}
	    }
	  RGBdata[j*LL*3+i*3+0]=size*alpha;
	  RGBdata[j*LL*3+i*3+1]=size*beta;
	  RGBdata[j*LL*3+i*3+2]=size*gamma;

	
       }


   sprintf(fname,"%s/FluxColorBar.png",dirname);
   PNGFileP = fopen(fname, "wb");
   png_ptr = png_create_write_struct(PNG_LIBPNG_VER_STRING,(png_voidp) NULL,
				     (png_error_ptr) NULL,
				     (png_error_ptr) NULL );
   if(!png_ptr){
     printf("out of memory\n");
     exit(1);
   }
   info_ptr = png_create_info_struct ( png_ptr );
   if(!info_ptr){
     png_destroy_write_struct(&png_ptr, NULL);
     printf("out of memory\n");
     exit(1);
   }
   png_init_io ( png_ptr, PNGFileP );
   png_set_IHDR(png_ptr, info_ptr,LL,WW,
		8, PNG_COLOR_TYPE_RGB, PNG_INTERLACE_NONE,
		PNG_COMPRESSION_TYPE_DEFAULT, PNG_FILTER_TYPE_DEFAULT);
   png_write_info ( png_ptr, info_ptr );
   /*write out image, one row at a time*/
   int row;
   for(row = WW-1; row >= 0; row--){
     row_pointer = ( RGBdata + LL * row * 3 );
     png_write_rows ( png_ptr, &row_pointer, 1 );
   }
   png_write_end ( png_ptr, info_ptr );
   fflush ( PNGFileP );
   png_destroy_write_struct ( &png_ptr,&info_ptr);
   fclose(PNGFileP);
}


void Tissue::MakeColorWheel()
{

   FILE *PNGFileP;
   png_structp png_ptr;
   png_infop info_ptr;
   png_bytep row_pointer;
   char fname[500];
   const int WW=zoom*300;
   const int LL=zoom*300;
   unsigned char RGBdata[LL*WW*3];
   int i,j;
   double v_i,v_j;
   
   double size,angle,dummy,alpha,beta,gamma;

   size=100;
   for(i=0;i<LL;i++)
     for(j=0;j<WW;j++)
       {
	 if((i-LL/2)*(i-LL/2)+(j-WW/2)*(j-WW/2)<150*150)
	   {
	     
	     v_i=i-LL/2;
	     v_j=j-WW/2;

	     //j to angle to color
	     angle=atan2(v_j,v_i);

	     size=1.5*sqrt(v_i*v_i+v_j*v_j);
	     //angle=-M_PI+((double)j/(double)WW)*2*M_PI;
	     if(angle<-M_PI)
	       {
		 //printf("warning flux angle smaller than -pi\n");
		 angle=-M_PI;
	       }
	     else if(angle>M_PI)
	       {
		 //printf("warning flux angle larger than pi\n");
		 angle=M_PI;
	       }
	     angle=angle+M_PI;//from 0 till 2*pi
	     
	     if(angle<(2./3.)*M_PI)
	       {
		 gamma=0;//no blue
		 dummy=angle/((2./3.)*M_PI);
		 if(dummy<=0.5)
		   {
		     alpha=1;
		     beta=2*dummy;
		   }
		 else
		   {
		     alpha=1-2*(dummy-0.5);//1-dummy;
		     beta=1;
		   }
	       }
	     else if(angle<(4./3.)*M_PI)
	       {
		 alpha=0;//no red
		 dummy=(angle-(2./3.)*M_PI)/((2./3.)*M_PI);
		 if(dummy<=0.5)
		   {
		     beta=1;
		     gamma=2*dummy;
		   }
		 else
		   {
		     gamma=1;
		     beta=1-2*(dummy-0.5);//1-dummy;
		   }
	       }
	     else
	       {
		 beta=0;//no green
		 dummy=(angle-(4./3.)*M_PI)/((2./3.)*M_PI);
		 if(dummy<=0.5)
		   {
		     gamma=1;
		     alpha=2*dummy;
		   }
		 else
		   {
		     alpha=1;
		     gamma=1-2*(dummy-0.5);//1-dummy;
		   }
	       }
	     RGBdata[j*LL*3+i*3+0]=size*alpha;
	     RGBdata[j*LL*3+i*3+1]=size*beta;
	     RGBdata[j*LL*3+i*3+2]=size*gamma;
	   }
	 else
	   {
	     RGBdata[j*LL*3+i*3+0]=254;
	     RGBdata[j*LL*3+i*3+1]=254;
	     RGBdata[j*LL*3+i*3+2]=254;
	   }
	
       }


   sprintf(fname,"%s/FluxColorWheel.png",dirname);
   PNGFileP = fopen(fname, "wb");
   png_ptr = png_create_write_struct(PNG_LIBPNG_VER_STRING,(png_voidp) NULL,
				     (png_error_ptr) NULL,
				     (png_error_ptr) NULL );
   if(!png_ptr){
     printf("out of memory\n");
     exit(1);
   }
   info_ptr = png_create_info_struct ( png_ptr );
   if(!info_ptr){
     png_destroy_write_struct(&png_ptr, NULL);
     printf("out of memory\n");
     exit(1);
   }
   png_init_io ( png_ptr, PNGFileP );
   png_set_IHDR(png_ptr, info_ptr,LL,WW,
		8, PNG_COLOR_TYPE_RGB, PNG_INTERLACE_NONE,
		PNG_COMPRESSION_TYPE_DEFAULT, PNG_FILTER_TYPE_DEFAULT);
   png_write_info ( png_ptr, info_ptr );
   /*write out image, one row at a time*/
   int row;
   for(row = WW-1; row >= 0; row--){
     row_pointer = ( RGBdata + LL * row * 3 );
     png_write_rows ( png_ptr, &row_pointer, 1 );
   }
   png_write_end ( png_ptr, info_ptr );
   fflush ( PNGFileP );
   png_destroy_write_struct ( &png_ptr,&info_ptr);
   fclose(PNGFileP);
}
